----------------------------------------------------------------------------
-----  AddOn:			ReadySetDing								--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----  Author:			Ketho (EU-Boulderfist Alliance CHN)			--------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----  Creation Date:	2010.01.04 (4 January 2010)					--------
-----  Text Editor:		Notepad++									--------	http://notepad-plus.sourceforge.net/
------ # Version -----------------------------------------------------------	http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
-----  ReadySetDing								 v0.74 [2010.10.29]	--------	http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
-----  Ace3 Development Framework				  r971 [2010.10.12]	--------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
------ # Features ----------------------------------------------------------
-----  01  Announce Time Taken for Ding								--------
-----  02  Compare Leveling Speed*									--------
------- # Index ------------------------------------------------------------
-----  01  OPTIONS AND DEFAULT VARIABLES							--------	Line   97
-----  02  OnInitialize, OnEnable, OnDisable						--------	Line  852
-----  03  CALLBACK HANDLERS										--------	Line  946
-----  04  EVENT HANDLERS											--------	Line 1339
----------------------------------------------------------------------------
-- Note: This is my 2nd AddOn (the first one is Ketho Combat)
-- I don't have any previous programming experience/background in any language

ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0") -- Instance of AceAddon Class; http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
local L = LibStub("AceLocale-3.0"):GetLocale("ReadySetDing", true) -- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/

---- Upvalues / speed optimizations ----
-- Lua functions -- http://www.wowpedia.org/Lua_functions  /  http://www.lua.org/manual/5.1/
local _G = getfenv(0) -- global table
local print = _G.print;
local tonumber = _G.tonumber;
local select = _G.select;
local date = _G.date; -- os.date (mirror)
local floor = _G.floor; -- math.floor
local mod = _G.mod; -- math.fmod
local random = _G.random; -- math.random
local strfind = _G.strfind; -- string.find
local strjoin = _G.strjoin; -- string.join (WoW Lua)
local strlen = _G.strlen; -- string.len
local strsub = _G.strsub; -- string.sub
local strtrim = _G.strtrim; -- string.trim (WoW Lua)
local format = _G.format; -- string.format
local gsub = _G.gsub; -- string.gsub
local sort = _G.sort; -- table.sort
local band = _G.bit.band -- BitLib library
-- WoW API -- http://www.wowpedia.org/World_of_Warcraft_API
local GetTime = GetTime;
local GuildRoster = GuildRoster;
local GuildRosterInfo = GetGuildRosterInfo;
local GS = GetStatistic;
local UnitName = UnitName;
local UnitClass = UnitClass;
local UnitInParty = UnitInParty;
local UnitInRaid = UnitInRaid;
local UnitGroupRolesAssigned = UnitGroupRolesAssigned;
local IsInInstance = IsInInstance;
local instanceType;
local IsInGuild = IsInGuild;
local GetRealZoneText = GetRealZoneText
local SCM = SendChatMessage;
local PSF = PlaySoundFile;
-- UnitFlags Masks -- http://www.wowpedia.org/UnitFlag
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY; -- 16(decimal) == 01000000(binary)
--local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL; -- 32(decimal) == 00100000(binary)
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE; -- 64(decimal) == 00010000(binary)
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1 -- 1048576(decimal)	== 100000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2 -- 2097152(decimal)	== 1000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3 -- 4194304(decimal)	== 10000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4 -- 8388608(decimal)	== 100000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5 -- 16777216(decimal)	== 1000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6 -- 33554432(decimal)	== 10000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7 -- 67108864(decimal)	== 100000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8 -- 134217728(decimal)	== 1000000000000000000000000000(binary)
-- Spell School Strings
local STRING_SCHOOL_PHYSICAL = STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_HOLY = STRING_SCHOOL_HOLY
local STRING_SCHOOL_FIRE = STRING_SCHOOL_FIRE
local STRING_SCHOOL_NATURE = STRING_SCHOOL_NATURE
local STRING_SCHOOL_FROST = STRING_SCHOOL_FROST
local STRING_SCHOOL_SHADOW = STRING_SCHOOL_SHADOW
local STRING_SCHOOL_ARCANE = STRING_SCHOOL_ARCANE
-- GlobalStrings.lua -- http://wowprogramming.com/utils/xmlbrowser/test/FrameXML/GlobalStrings.lua
local YOU = YOU;
local QUICKBUTTON_NAME_SELF = QUICKBUTTON_NAME_SELF;
local ACTION_UNIT_DIED = ACTION_UNIT_DIED;
local MELEE = MELEE;
local PVP = PVP;
local DEFAULT = DEFAULT;
-- Abbreviations
local RSD = ReadySetDing;
local iconCropped = "1:0:64:64:4:60:4:60"; -- Cropped Texture (1pixel to the right for Ketho Combat Log icons) -- http://www.wowpedia.org/UI_escape_sequences
local RaidTarget = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_"
---- File-local Scope variables ----
local playerName = UnitName("player");
local playerLevel = UnitLevel("player");
local playerRace = UnitRace("player");
local _, playerClass = UnitClass("player"); local playerColor;
local englishFaction, playerFaction = UnitFactionGroup("player");
local playerRealm = GetRealmName();
local expansionLevel = GetAccountExpansionLevel(); local playerDinged; local maxLevel = 80; -- player variables; local playerGuild = GetGuildInfo("player"); (guildinfo not readily available..)
local lastRequestedPlayedTime = GetTime(); local currentLevelTimeSnapshot; local totalLevelTimeSnapshot; local levelTime; local levelTime2; local timeInstance = 0; local timeInstance2 = 0; local timeInstanceStart; local timeInstanceStart2; local timeInstanceEnd; local timeAFK1; local timeAFK2; local timeLogin; -- time variables
local cd_randomIcon1 = 0; local cd_playSound = 0; local cd_realZone = 0; local cd_autoGratzP = 0; local cd_autoGratzG = 0; local cd_StatisticDeathsPvP = 0; local cd_StatisticTotalQuests = 0; local cd_StatisticTotalKillingBlows = 0; local cd_checkMsgLength = 0; local cd_PlayerDeath = 0; local cd_PlayerKill = 0; local cd_IsInInstance = 0; -- cooldown / throttle
local TPM_currentLevelTime = 0; local TPM_currentLevelTime2; local TPM_totalTime = 0; local TPM_totalTime2 = 0; local PLU_level; -- event variables
local CF; local randomIcon1; local soundPath; local realZone; local gratzName; local lastDeath; local firstUpdate; -- rest vars
local bgKills; local arenaKills; local totalDeaths; local PvP_WSG; local PvP_AB; local PvP_AV; local PvP_EotS; local PvP_SotA; local PvP_arena22; local PvP_arena33; local PvP_arena55; local questsTotal; local questsDaily; -- RSD_AchievementStatistics() File-local variables; dont understand why it wasnt working inside that function, but need it for in options tables anyway actually

	-----------------------------------------------
	-----  01  OPTIONS AND DEFAULT VARIABLES  -----
	-----------------------------------------------
--- Blizzard GUI Options --- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local optionsMain = {
    type = 'group',
	name = "\124cffADFF2FReadySet\124r|cffFFFFFFDing|r |cffB6CA00v0.74|r                               |cffFFFFFF2010.10.29|r", -- Main Options Header
	handler = RSD,
	args = {
		toggleEnableAddOn = {
			type = "toggle",
			order = 1,
			descStyle = "no tooltip plz",
			name = "|cff71D5FF"..L["Enable AddOn"].."|r", -- TestLocale Method 2: Without the UI Escape Sequence Coloring
			get = function(info) return RSD.db.profile.enableAddOn end,
			set = function(info, value) RSD.db.profile.enableAddOn = value
				if RSD.db.profile.enableAddOn == true then RSD:Enable() -- Turn AddOn on
				elseif RSD.db.profile.enableAddOn == false then RSD:Disable() -- Turn AddOn off
				end
			end,
		},
		toggleScreenshot = {
			type = "toggle",
			order = 3,
			descStyle = "no tooltip plz",
			name = "|TInterface\\Icons\\inv_misc_spyglass_03:22:22:"..iconCropped.."|t  "..L["Take Screenshot"],
			get = function(info) return RSD.db.profile.Screenshot end,
			set = function(info, value) RSD.db.profile.Screenshot = value end,
			disabled = "OptionsDisabled",
		},
		toggleAutoGratz = {
			type = "toggle",
			order = 5,
			descStyle = "no tooltip plz",
			name = "|TInterface\\Icons\\INV_Misc_Gift_05:20:20:"..iconCropped.."|t  "..L["Auto Gratz"],
			get = function(info) return RSD.db.profile.AutoGratz end,
			set = function(info, value) RSD.db.profile.AutoGratz = value end,
			disabled = "OptionsDisabled",
		},
		toggleNormalAnnounce = {
			type = "toggle",
			order = 2,
			descStyle = "no tooltip plz",
			name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:3:0:32:32:2:30:2:30|t   "..L["Normal Announce"],
			get = function(info) return RSD.db.profile.normalAnnounce end,
			set = function(info, value) RSD.db.profile.normalAnnounce = value end,
			disabled = "OptionsDisabled",
		},
		toggleGuildAnnounce = {
			type = "toggle",
			order = 4,
			descStyle = "no tooltip plz", -- http://www.wowpedia.org/API_Texture_SetTexCoord
			name = function() return RSD_GuildEmblem()..L["Guild Announce"]; end,
			get = function(info) return RSD.db.profile.guildAnnounce end,
			set = function(info, value) RSD.db.profile.guildAnnounce = value end,
			disabled = "OptionsDisabled",
		},
		toggleBNetBroadcast = {
			type = "toggle",
			order = 6,
			desc = BN_BROADCAST_TOOLTIP,
			name = function() if GetTime() > cd_randomIcon1 then cd_randomIcon1 = GetTime() + 300; local a = random(1, 4)
				if	   a <= 2 then randomIcon1 = "PlusManz-BattleNet" -- 64px original size; ...\Data\enGB\locale-enGB.MPQ\Interface\FriendsFrame\PlusManz-BattleNet.blp
				elseif a == 3 then randomIcon1 = "Battlenet-WoWicon" -- 32px original size
				elseif a == 4 then randomIcon1 = "Battlenet-Sc2icon"
			end; end; return "|TInterface\\FriendsFrame\\"..randomIcon1..":24|t  "..L["Real ID Broadcast"]; end,
			get = function(info) return RSD.db.profile.BNetBroadcast end,
			set = function(info, value) RSD.db.profile.BNetBroadcast = value end,
			disabled = "OptionsDisabled",
		},
		inputDingMessage = {
			type = "input",
			order = 7,
			width = "full",
		--	multiline = true, -- prefer normal one over multiline
			name = " ", -- If it was like "" then "usage" wouldnt appear
			usage = "\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffF6ADC6[LEVEL]|r |cffFFFFFF= "..L["New Level"].."|r\n|cffF6ADC6[LEVEL#]|r |cffFFFFFF= "..L["Remaining Levels"].."|r\n|cffF6ADC6[LEVEL+]|r |cffFFFFFF= "..L["Max Level"].."|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Level Time"].."|r\n|cff71D5FF[TOTAL]|r |cffFFFFFF= "..L["Total Time"].."|r\n|cff71D5FF[DIFF]|r |cffFFFFFF= "..L["Time Difference"].."|r\n|cff71D5FF[AFK]|r, |cff71D5FF[AFK+]|r |cffFFFFFF= "..L["AFK Time"].."|r\n|cff0070DD[DATE]|r  |cffFFFFFF=|r |cff0070DDMM/DD/YY hh:mm|r\n|cff0070DD[DATE2]|r |cffFFFFFF=|r |cff0070DDYYYY.MM.DD hh:mm|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["Recent LevelSpeed"].."|r|cffB6CA00(5)|r\n|cffB6CA00[SPEED+]|r |cffFFFFFF= "..L["Average LevelSpeed"].."|r\n|cffFF0000[KILLS]|r, |cffFF0000[KILLS+]|r |cffFFFFFF= "..L["Kills"].."|r\n|cffFF0000[DEATHS], |cffFF0000[DEATHS+]|r |cffFFFFFF= "..L["Deaths"].."|r\n|cff58ACFA[QUESTS]|r |cffFFFFFF= "..L["Quests Completed"].."|r\n|cff58ACFA[ZONE]|r |cffFFFFFF= "..L["Your Location"].."|r\n|cffADFF2F[NAME]|r, |cffADFF2F[CLASS]|r, |cffADFF2F[RACE]|r, |cffADFF2F[GUILD]|r, |cffADFF2F[FACTION]|r, |cffADFF2F[REALM]|r\n"..L["Raid Target Icons"]..": |cffFFFFFF{Moon} |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:12|t|r\n\n"..L["Make sure to press [Enter] / [Okay]"],
			get = function(info) return RSD.db.profile.dingMessage end,
			set = function(info, value) RSD.db.profile.dingMessage = value
				if string.trim(RSD.db.profile.dingMessage) == "" then RSD.db.profile.dingMessage = RSD.db.defaults.profile.dingMessage; end; end,
			disabled = "OptionsDisabled",
		},
		descriptionExample = {
			type = "description",
			order = 8,
			name = function() return "|cffB6CA00Example:|r  "..RSD_ReplaceText(RSD.db.profile.dingMessage, "ExampleDingMsg"); end,
		},
		header = {
			type = "header",
			order = 9,
			name = "",
		},
		descriptionLevelSummary = {
			type = "description",
			order = 10,
			name = function() return RSD_LevelSummary("LevelSummaryMenu"); end,
		},
	},
}

local optionsAdvanced = {
	type = "group",
	name = "",
	handler = RSD,
	args = {
		toggleGratzAllAchievements = {
			type = "toggle",
			order = 1,
			width = "full",
			descStyle = "no tooltip plz",
			name = "|TInterface\\Icons\\Achievement_Reputation_06:22:22:"..iconCropped.."|t  "..L["AutoGratz for any Guild Achievements"],
			get = function(info) return RSD.db.profile.gratzAllAchievements end,
			set = function(info, value) RSD.db.profile.gratzAllAchievements = value end,
			disabled = function() if RSD.db.profile.enableAddOn == false or RSD.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		toggleGuildLevelup = {
 			type = "toggle",
			order = 2,
			width = "full",
			tristate = true, -- did some /facedesks while trying to design this option (><)\
			descStyle = "no tooltip plz",
			name = function()
				if RSD.db.profile.GuildLevelup == true then return RSD_GuildEmblem()..L["Show Guild Dings"];
				elseif RSD.db.profile.GuildLevelup == false then return RSD_GuildEmblem()..L["Show/Announce Guild Dings"];
				elseif not RSD.db.profile.GuildLevelup then return RSD_GuildEmblem()..L["Announce Guild Dings"];
				end; end,
			get = function(info) return RSD.db.profile.GuildLevelup end,
			set = function(info, value) RSD.db.profile.GuildLevelup = value;
				if RSD.db.profile.GuildLevelup == false and IsInGuild() then RSD:CancelTimer(RSD.GuildRosterTimer); -- cancel timer
				elseif RSD.db.profile.GuildLevelup == true and IsInGuild() then RSD.GuildRosterTimer = RSD:ScheduleRepeatingTimer(function() GuildRoster(); end, 17); -- trying not to create a new timer function; only enable at "local", then for "announce" its already enabled
				end; end,
			disabled = "OptionsDisabled",
		},
		header01 = {
			type = "header",
			order = 3,
			name = "",
		},
		rangeAutoGratzCooldown = {
			type = "range",
			order = 4,
			desc = "|cff71D5FFsoftMax|r = 120 "..L["seconds"].." |cffB6CA00Slider Input|r\n|cff71D5FFmax|r = 600 "..L["seconds"].." (|cffB6CA00Manual Input|r)\n|cffF6ADC6"..DEFAULT.."|r = 60 "..L["seconds"].."",
			name = "|TInterface\\Icons\\INV_Misc_Gift_05:18:18:"..iconCropped.."|t "..L["AutoGratz Cooldown"],
			get = function(info) return RSD.db.profile.autoGratzCooldown end,
			set = function(info, value) RSD.db.profile.autoGratzCooldown = value end,
			min = 0, softMin = 0,
			max = 600, softMax = 120,
			disabled = function() if RSD.db.profile.enableAddOn == false or RSD.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		rangeScreenshotDelay = {
			type = "range",
			order = 5,
			desc = "|cff71D5FFsoftMax|r = 2 "..L["seconds"].." (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 60 "..L["seconds"].." (|cffB6CA00Manual Input|r)\n|cffF6ADC6"..DEFAULT.."|r = 1 "..L["second"].."",
			name = "|TInterface\\Icons\\inv_misc_spyglass_03:18:18:"..iconCropped.."|t "..L["Screenshot Delay"],
			get = function(info) return RSD.db.profile.screenshotDelay end,
			set = function(info, value) RSD.db.profile.screenshotDelay = value end,
			min = 0, softMin = 0,
			max = 60, softMax = 2,
			disabled = function() if RSD.db.profile.enableAddOn == false or RSD.db.profile.Screenshot == false then return true; else return false; end; end,
		},
		rangeAutoGratzDelay = {
			type = "range",
			order = 6,
			desc = "|cff71D5FFsoftMax|r = 10 "..L["seconds"].." (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 60 "..L["seconds"].." (|cffB6CA00Manual Input|r)\n|cffF6ADC6"..DEFAULT.."|r = 0 (|cffFF8000Random 2-10 "..L["seconds"].."|r)",
			name = "|TInterface\\Icons\\INV_Misc_Food_147_Cake:18:18:"..iconCropped.."|t "..L["AutoGratz Delay"],
			get = function(info) return RSD.db.profile.autoGratzDelay end,
			set = function(info, value) RSD.db.profile.autoGratzDelay = value end,
			min = 0, softMin = 0,
			max = 60, softMax = 10,
			disabled = function() if RSD.db.profile.enableAddOn == false or RSD.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		rangeAnnounceDelay = {
			type = "range",
			order = 7,
			desc = "|cff71D5FFsoftMax|r = 10 "..L["seconds"].." (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 60 "..L["seconds"].." (|cffB6CA00Manual Input|r)\n|cffF6ADC6"..DEFAULT.."|r = 0 "..L["seconds"].."",
			name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:18:18:"..iconCropped.."|t "..L["Announce Delay"],
			get = function(info) return RSD.db.profile.announceDelay end,
			set = function(info, value) RSD.db.profile.announceDelay = value end,
			min = 0, softMin = 0,
			max = 60, softMax = 10,
			disabled = function() if RSD.db.profile.enableAddOn == false or (RSD.db.profile.BNetBroadcast == false and RSD.db.profile.normalAnnounce == false and RSD.db.profile.guildAnnounce == false) then return true; else return false; end; end,
		},
		header02 = {
			type = "header",
			order = 8,
			name = "",
		},
		inputGuildDingMsg = {
			type = "input",
			order = 9,
			width = "full",
			name = function()
				if GuildFrameTabardEmblem then RSD.db.char.guildTexCoord = {GuildFrameTabardEmblem:GetTexCoord()}; end
				if IsInGuild() and #RSD.db.char.guildTexCoord > 0 then return "   |TInterface\\GuildFrame\\GuildEmblemsLG_01:28:28:0:0:32:32:"..(RSD.db.char.guildTexCoord[1]*32)..":"..(RSD.db.char.guildTexCoord[7]*32)..":"..(RSD.db.char.guildTexCoord[2]*32)..":"..(RSD.db.char.guildTexCoord[8]*32).."|t"..L["Guild Ding Message"];
				else return "   |TInterface\\GuildFrame\\GuildLogo-NoLogo:28:28:0:0|t"..L["Guild Ding Message"];
				end; end,
			usage = "\n|cff58ACFA[NAME]|r, |cff58ACFA[LEVEL], |cff58ACFA[LEVEL-]|r, |cff58ACFA[CLASS]|r, |cff58ACFA[RANK]|r, |cff58ACFA[ZONE]|r, |cff58ACFA[TESTDIFF]|r (Realtime)\n"..L["Make sure to press [Enter] / [Okay]"],
			get = function(info) return RSD.db.profile.guildDingMsg end,
			set = function(info, value) RSD.db.profile.guildDingMsg = value
				if string.trim(RSD.db.profile.guildDingMsg) == "" then RSD.db.profile.guildDingMsg = RSD.db.defaults.profile.guildDingMsg; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg1 = {
			type = "input",
			order = 10,
			width = "full",
			name = "    |TInterface\\Icons\\INV_Misc_Gift_05:18:18:"..iconCropped.."|t "..L["AutoGratz Random Messages"],
			usage = "\n|cff58ACFA[NAME]|r\n"..L["Make sure to press [Enter] / [Okay]"],
			get = function(info) return RSD.db.profile.autoGratzMsg1 end,
			set = function(info, value) RSD.db.profile.autoGratzMsg1 = value
				if string.trim(RSD.db.profile.autoGratzMsg1) == "" then RSD.db.profile.autoGratzMsg1 = RSD.db.defaults.profile.autoGratzMsg1; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg2 = {
			type = "input",
			order = 11,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return RSD.db.profile.autoGratzMsg2 end,
			set = function(info, value) RSD.db.profile.autoGratzMsg2 = value
				if string.trim(RSD.db.profile.autoGratzMsg2) == "" then RSD.db.profile.autoGratzMsg2 = RSD.db.defaults.profile.autoGratzMsg2; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg3 = {
			type = "input",
			order = 12,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return RSD.db.profile.autoGratzMsg3 end,
			set = function(info, value) RSD.db.profile.autoGratzMsg3 = value
				if string.trim(RSD.db.profile.autoGratzMsg3) == "" then RSD.db.profile.autoGratzMsg3 = RSD.db.defaults.profile.autoGratzMsg3; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg4 = {
			type = "input",
			order = 13,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return RSD.db.profile.autoGratzMsg4 end,
			set = function(info, value) RSD.db.profile.autoGratzMsg4 = value
				if string.trim(RSD.db.profile.autoGratzMsg4) == "" then RSD.db.profile.autoGratzMsg4 = RSD.db.defaults.profile.autoGratzMsg4; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg5 = {
			type = "input",
			order = 14,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return RSD.db.profile.autoGratzMsg5 end,
			set = function(info, value) RSD.db.profile.autoGratzMsg5 = value
				if string.trim(RSD.db.profile.autoGratzMsg5) == "" then RSD.db.profile.autoGratzMsg5 = RSD.db.defaults.profile.autoGratzMsg5; end; end,
			disabled = "OptionsDisabled",
		},
	},
}

local optionsCombat = {
	type = "group",
	name = "",
	handler = RSD,
	args = {
		header1 = {
			type = "header",
			order = 1,
			name = function() local a; if englishFaction == "Alliance" then a = "War3_MountainKing"; elseif englishFaction == "Horde" then a = "War3_Blademaster"; end
				return "|TInterface\\AddOns\\ReadySetDing\\Images\\"..a..":28:28:-4:-8:64:64|t |cffADFF2FKetho|r |cffFFFFFFCombat|r Log|TInterface\\LFGFRAME\\UI-LFG-ICONS-ROLEBACKGROUNDS:55:70:55:-455:256:128:80:150:10:65|t                                          "
				end,
		},
		description = {
			type = "description",
			order = 2,
			name = " ",
		},
		toggleTaunt = {
			type = "toggle",
			order = 3,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:22:22:"..iconCropped.."|t  |cffFF0000"..L["Taunts"].."|r"; end,
			get = function(info) return RSD.db.profile.Taunt end,
			set = function(info, value) RSD.db.profile.Taunt = value end,
			disabled = "OptionsDisabled",
		},
		toggleInterrupt = {
			type = "toggle",
			order = 5,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Ability_Kick:22:22:"..iconCropped.."|t  |cff006EFF"..L["Interrupts"].."|r"; end,
			get = function(info) return RSD.db.profile.Interrupt end,
			set = function(info, value) RSD.db.profile.Interrupt = value end,
			disabled = "OptionsDisabled",
		},
		toggleDispel = {
			type = "toggle",
			order = 7,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Spell_Holy_DispelMagic:22:22:"..iconCropped.."|t  |cff71D5FF"..L["Dispels"].."|r"; end,
			get = function(info) return RSD.db.profile.Dispel end,
			set = function(info, value) RSD.db.profile.Dispel = value end,
			disabled = "OptionsDisabled",
		},
		toggleReflect = {
			type = "toggle",
			order = 9,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:22:22:"..iconCropped.."|t  |cff71D5FF"..L["Reflects"].."|r"; end,
			get = function(info) return RSD.db.profile.Reflect end,
			set = function(info, value) RSD.db.profile.Reflect = value end,
			disabled = "OptionsDisabled",
		},
		toggleDeath = {
			type = "toggle",
			order = 4,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Ability_Rogue_FeignDeath:22:22:"..iconCropped.."|t  |cffBA0000"..L["Deaths"].."|r"; end,
			get = function(info) return RSD.db.profile.Death end,
			set = function(info, value) RSD.db.profile.Death = value end,
			disabled = "OptionsDisabled",
		},
		toggleResurrection = {
			type = "toggle",
			order = 6,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Spell_Holy_Resurrection:22:22:"..iconCropped.."|t  |cffC6DC00"..L["Resurrections"].."|r"; end,
			get = function(info) return RSD.db.profile.Resurrection end,
			set = function(info, value) RSD.db.profile.Resurrection = value end,
			disabled = "OptionsDisabled",
		},
		toggleCC_Applied = {
			type = "toggle",
			order = 8,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:22:22:"..iconCropped.."|t  |cff71D5FF"..L["Crowd Control"].."|r"; end,
			get = function(info) return RSD.db.profile.CC_Applied end,
			set = function(info, value) RSD.db.profile.CC_Applied = value end,
			disabled = "OptionsDisabled",
		},
		toggleCC_Break = {
			type = "toggle",
			order = 10,
			descStyle = "no tooltip plz",
			name = function() return "|TInterface\\Icons\\Ability_Seal:22:22:"..iconCropped.."|t  |cffFF7800"..L["CC Breaker"].."|r"; end,
			get = function(info) return RSD.db.profile.CC_Break end,
			set = function(info, value) RSD.db.profile.CC_Break = value end,
			disabled = "OptionsDisabled",
		},
		header2 = {
			type = "header",
			order = 11,
			name = "",
		},
		toggleCombatPvE = {
			type = "toggle",
			order = 12,
			width = "full",
			descStyle = "no tooltip plz",
			name = "|cffA8A8FF"..L["PvE"].."|r", -- /dump ChatTypeInfo.PARTY; {r = 0.666, g = 0.666, b = 1.000}
			get = function(info) return RSD.db.profile.combatPvE end,
			set = function(info, value) RSD.db.profile.combatPvE = value end,
			disabled = "OptionsDisabled",
		},
		toggleCombatPvP = {
			type = "toggle",
			order = 13,
			width = "full",
			descStyle = "no tooltip plz",
			name = "|cffFF7F00"..L["PvP"].."|r", -- /dump ChatTypeInfo.RAID; {r = 1.000, g = 0.498, b = 0.000}
			get = function(info) return RSD.db.profile.combatPvP end,
			set = function(info, value) RSD.db.profile.combatPvP = value end,
			disabled = "OptionsDisabled",
		},
		toggleCombatWorld = {
			type = "toggle",
			order = 14,
			width = "full",
			descStyle = "",
			name = "|cff71D5FF"..L["World"].."|r",
			get = function(info) return RSD.db.profile.combatWorld end,
			set = function(info, value) RSD.db.profile.combatWorld = value end,
			disabled = "OptionsDisabled",
		},
		selectChatFrameOutput = {
			type = "select",
			order = 15,
			name = L["Local ChatFrame Output"],
			desc = "|cff71d5ff"..CHARACTER.." Specific|r", -- chatframes can be different on "positions" on different characters; new characters also would need the default chatframe, since they always start out with 1 chatframe
			values = function() local ChatWindowNames = {}; for i = 1, NUM_CHAT_WINDOWS do if i == 1 then ChatWindowNames[1] = "|cff2E9AFE1.|r  "..(select(1, GetChatWindowInfo(1))).." |cffFBDB00("..DEFAULT..")|r"; else ChatWindowNames[i] = "|cff2E9AFE"..i..".|r  "..(select(1, GetChatWindowInfo(i))) end; end; return ChatWindowNames; end,
			get = function(info) return RSD.db.char.chatFrame end,
			set = function(info, value) RSD.db.char.chatFrame = value; CF = _G["ChatFrame"..RSD.db.char.chatFrame]; CF:AddMessage("|cffADFF2FReadySet|rDing: This is now the Output ChatFrame: |cff57A3FF"..RSD.db.char.chatFrame..". "..select(1, GetChatWindowInfo(RSD.db.char.chatFrame)).."|r"); end,
			disabled = "OptionsDisabled",
		},
		header3 = {
			type = "header",
			order = 16,
			name = "",
		},
		toggleTankTaunt = {
			type = "toggle",
			order = 17,
			width = "full",
			descStyle = "",
			name = "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:24:24:0:0:256:256:1:65:68:132|t |TInterface\\Icons\\Spell_Nature_Reincarnation:18:18:"..iconCropped.."|t  "..L["Tank Taunts"], -- #001B52 Original Tank color
			set = function(info, value) RSD.db.profile.tankTaunt = value end,
			get = function(info) return RSD.db.profile.tankTaunt end,
			disabled = "OptionsDisabled",
		},
		toggleTankBreaksCC = {
			type = "toggle",
			order = 18,
			width = "full",
			descStyle = "",
			name = "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:24:24:0:0:256:256:1:65:68:132|t |TInterface\\Icons\\Ability_Seal:18:18:"..iconCropped.."|t  "..L["Tank CC Breaks"],
			set = function(info, value) RSD.db.profile.tankBreaksCC = value end,
			get = function(info) return RSD.db.profile.tankBreaksCC end,
			disabled = "OptionsDisabled",
		},
		togglePetGrowl = {
			type = "toggle",
			order = 19,
			width = "full",
			descStyle = "",
			name = " |TInterface\\Icons\\INV_Weapon_Bow_07:18:18:2:0:32:32:2:30:2:30|t  |TInterface\\Icons\\Ability_Physical_Taunt:18:18:-1:0:32:32:2:30:2:30|t  "..L["Pet Growl"],
			set = function(info, value) RSD.db.profile.petGrowl = value end,
			get = function(info) return RSD.db.profile.petGrowl end,
			disabled = "OptionsDisabled",
		},
	},
}

local optionsInstanceTimer = {
	type = "group",
	name = "",
	handler = RSD,
	args = {
		toggleInstanceTimer = {
			type = "toggle",
			order = 1,
			descStyle = "no tooltip plz",
			width = "full",
			name = "|TInterface\\Icons\\Spell_Holy_BorrowedTime:24:24:3:0:32:32:2:30:2:30|t  |cff71D5FF"..L["Instance Timer"].."|r",
			get = function(info) return RSD.db.profile.instanceTimer end,
			set = function(info, value) RSD.db.profile.instanceTimer = value end,
			disabled = "OptionsDisabled",
		},
		description1 = {
			type = "description",
			order = 2,
			name = " ",
		},
		inputInstanceTimerMsg = {
			type = "input",
			order = 3,
			width = "full",
			name = "  |cffFFFFFF"..L["Instance Timer Message"],
			usage = "\n|cff58ACFA[ZONE]|r |cffFFFFFF= "..L["Instance Name"].."|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Run Time"].."|r\n|cffADFF2F[START]|r |cffFFFFFF= "..L["Start Time"].."|r\n|cffF6ADC6[END]|r |cffFFFFFF= "..L["End Time"].."|r\n\n"..L["Make sure to press [Enter] / [Okay]"],
			get = function(info) return RSD.db.profile.instanceTimerMsg end,
			set = function(info, value) RSD.db.profile.instanceTimerMsg = value
				if string.trim(RSD.db.profile.instanceTimerMsg) == "" then RSD.db.profile.instanceTimerMsg = RSD.db.defaults.profile.instanceTimerMsg; end; end,
			disabled = "OptionsDisabled",
		},
		descriptionExample = {
			type = "description",
			order = 4,
			name = function() return "  |cffB6CA00"..L["Example"]..":|r  "..RSD_ReplaceText(RSD.db.profile.instanceTimerMsg, "ExampleInstanceTimerMsg"); end,
		},
		description2 = {
			type = "description",
			order = 5,
			name = " ",
		},
		header02 = {
			type = "header",
			order = 6,
			name = "",
		},--[[
		executePrintInstanceTimer = {
			type = "execute",
			order = 7,
			descStyle = "no tooltip plz",
			name = L["Show Instance Times"],
			func = function()
				if RSD.db.char.timeInstanceList and #RSD.db.char.timeInstanceList > 0 then -- code by Xinhuan from WowAce.com -- http://forums.wowace.com/showthread.php?p=306562#post306562
					local t = {}; local i = 1
					for k, v in pairs(RSD.db.char.timeInstanceList) do
						t[i] = k -- Take all the keys of t1[] and put them in t as values
						i = i + 1
					end
					sort(t)
					for i = 1, #t do -- Now print out key = value in sorted order
						print("["..t[i].."] = "..RSD.db.char.timeInstanceList[ t[i] ])
					end
				else print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No InstanceTimer Data"].."]|r")
				end
			end,
			disabled = "OptionsDisabled",
			},--]]
		descriptionInstanceTimer = {
			type = "description",
			order = 8,
			name = function() local a = select(2, IsInInstance());
				if timeInstance > 0 and a == "party" and GetRealZoneText() then return "\n  Time in |cffA8A8FF"..GetRealZoneText().."|r = |cff71D5FF"..RSD_TimetoString(GetTime()-timeInstance).."|r,  Started: |cffADFF2F"..timeInstanceStart.."|r"
				elseif timeInstance > 0 and a ~= "party" then return "\n  "..L["Time in Instance"].." = |cff71D5FF"..RSD_TimetoString(GetTime()-timeInstance).."|r"
				else return "\n  "..L["Time in Instance"].." = |cffF6ADC6N/A|r"
				end; end,
		},
--[[ -- planning Instance Times summary for v0.71+
		descriptionTimer = {
			type = "description",
			order = 20,
			name = function() if timeInstance > 0 then return "|cffB6CA00Example:|r  [Instance] cleared in "..RSD_TimetoString(GetTime() - timeInstance) else return "|cffB6CA00Example:|r |cffF6ADC6[No Instance Time Data Found]|r" end; end,
		},
--]]
	},
}

local optionsAbout = {
	type = "group",
	name = "",
	handler = RSD,
	args = {
		header01 = {
			type = "header",
			order = 1,
			name = "|cffADFF2FReadySet|r|cffFFFFFFDing|r by |cffFFFFFFKetho|r @ |cffB6CA00EU-Boulderfist|r",
		},
		descriptionAddOn = {
			type = "description",
			order = 2, -- the UI escape sequence gets broken off a lot down here ...
			name = "\n|cff87CEFAhttp://wow.|r|cffADFF2Fcurse|r|cff87CEFA.com/downloads/wow-addons/details/readysetding.aspx\nhttp://www.|r|cffADFF2Fwowinterface|r|cff87CEFA.com/downloads/info16220-ReadySetDing.html|r",
		},
		descriptionCommands = {
			type = "description",
			order = 3,
			name = L["Chat commands:"].."  /rsd, /readysetding",
		},
		header02 = {
			type = "header",
			order = 4,
			name = "",
		},
		descriptionChangeLogToDo = {
			type = "description",
			order = 5,
			name = "|cffADFF2Fv0.74|r: Fixed: Real ID Broadcast, Instance Backup Timer\nAdded: German Locale by |cff1FFF1CFreydis88|r, |cff1FFF1CMelikae|r and |cff1FFF1CLittlelizzi|r\n\n|cff71D5FFTo Do|r |cffB6CA00|cffB6CA00v0.80|r: Compare Guild Levels",
		},
		header03 = {
			type = "header",
			order = 6,
			name = "",
		},
		descriptionLevelDifference = {
			type = "description",
			order = 7, -- have to do it like this, since it returns "14 minutes faster" / "[No TimeDiff Data]"
			name = function() if RSD_timeDiff("exampleMsg") ~= "["..L["No TimeDiff Data"].."]" then return L["Time Difference"].." = |cff71D5FF"..RSD_timeDiff("exampleMsg").."|r "..L["than last Level"]
				else return L["Time Difference"].." = |cffF6ADC6["..L["No TimeDiff Data"].."]|r" end; end,
		},
		descriptionLevelSpeedRecent = {
			type = "description",
			order = 8,
			name = function() if RSD_recentLevelSpeed() ~= "["..L["No LevelSpeed Data"].."]" then return L["Recent LevelSpeed"].." = |cffB6CA00"..RSD_TimetoString(RSD_recentLevelSpeed()).."|r/"..L["Level"].." = |cffB6CA00"..format("%.2f",RSD_recentLevelSpeed()/3600).." "..L["hours"].."|r/"..L["Level"]
				else return L["Recent LevelSpeed"].." = |cffF6ADC6["..L["No LevelSpeed Data"].."]|r" end; end,
		},
		descriptionLevelSpeedAverage = {
			type = "description",
			order = 9,
			name = function() if playerLevel > 1 then return L["Average LevelSpeed"].." = |cff71D5FF"..RSD_TimetoString((TPM_totalTime+RSD_addedTime())/(playerLevel-1)).."|r/"..L["Level"].." = |cff71D5FF"..format("%.2f",((TPM_totalTime+RSD_addedTime())/3600)/(playerLevel-1)).." "..L["hours"].."|r/"..L["Level"]
				else return L["Average LevelSpeed"].." = |cffF6ADC6["..L["No LevelSpeed Data"].."]|r" end; end,
		},
		descriptionTimeAFK = {
			type = "description",
			order = 10,
			name = function() return L["AFK Time"].." = |cffB6CA00"..RSD_TimetoString(RSD.db.char.timeAFK).."|r, "..L["Total AFK Time"].." = |cffB6CA00"..RSD_TimetoString(RSD.db.char.totalAFK).."|r"; end,
		},
		descriptionXP_Kills = {
			type = "description",
			order = 11,
			name = function() return COMBAT_XP_GAIN..": |cffB6CA00"..UnitXP("player").."|r / |cff71D5FF"..UnitXPMax("player").."|r = |cffADFF2F"..floor((UnitXP("player")/UnitXPMax("player"))*100).."%|r, "..L["Kills"].." = |cffFF0000"..RSD.db.char.killingBlows.."|r, "..L["Total Kills"].." = |cffFF0000"..RSD_AchievementStatistics("TotalKillingBlows").."|r"; end,
		},
		descriptionDeaths = {
			type = "description",
			order = 12,
			name = function() return L["Deaths"].." = |cffFF0000"..RSD.db.char.deathCount.."|r, "..L["Total Deaths"].." = |cffFF0000"..RSD_AchievementStatistics("excludeDeathsPvP").."|r, "..L["Total Deaths"].."(+"..PVP..") = |cffFF0000"..RSD_AchievementStatistics("TotalDeaths").."|r"; end,
		},
		descriptionQuests = {
			type = "description",
			order = 13,
			name = function() local GS = GetStatistic; if GetTime() > cd_StatisticTotalQuests then cd_StatisticTotalQuests = GetTime() + 60
				if GS(98) == "--" then questsTotal = 0; else questsTotal = tonumber(GS(98)); end
				if GS(97) == "--" then questsDaily = 0; else questsDaily = tonumber(GS(97)); end
				end; return L["Quests Completed"].." = |cff58ACFA"..questsTotal-questsDaily.."|r, "..L["Daily Quests"].." = |cff58ACFA"..questsDaily.."|r"; end,
		},
		header04 = {
			type = "header",
			order = 14,
			name = "",
		},
		executePrintTimes = {
			type = "execute",
			order = 15,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t "..L["Show LevelTimes"],
			func = function()
				if not RSD.db.char.levelTimeList or #RSD.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Data"].."]|r"); end
				for i = 2, maxLevel do if RSD.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD_TimetoString(RSD.db.char.levelTimeList[i]).."|r   "..L["Total"]..": |cff71D5FF"..RSD_TimetoString(RSD.db.char.totalTimeList[i]).."|r"); end; end
				end,
			disabled = "OptionsDisabled",
		},
		executePlaySound = {
			type = "execute",
			order = 16,
			name = "|TSPELLS\\HOLIDAYS\\Heart:18|t "..L["Play Sound"], -- ...\Data\common.MPQ\SPELLS\HOLIDAYS\Heart.blp
			func = function() -- yeah .. well .. was just a little bored, maybe a little easter egg \(n_n)/
				if GetTime() > cd_playSound then cd_playSound = GetTime() + 3
					local randomSound1 = random(1, 11); local descEnd = "|r|cffB6CA00.wav\")|r"; local descInterface = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Interface\\\\|r|cff71D5FF"; local descSpell = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Spells\\\\|r|cff71D5FF" -- "\\\\" -> \\
					if randomSound1 <= 10 then local randomSound2 = random(1, 10); -- For some reason the color UI escape code gets broken off by the 2nd one in soundPath; had to do it again after that 2nd one
						if	   randomSound2 >= 1 and randomSound2 <= 3 then PSF("Sound\\Interface\\LevelUp.wav"); soundPath = descInterface.."LevelUp"..descEnd; -- ...\Data\common.MPQ\Sound\Interface\LevelUp.wav -- Player Leveled Up
						elseif randomSound2 >= 4 and randomSound2 <= 6 then PSF("Sound\\Interface\\iQuestComplete.wav"); soundPath = descInterface.."iQuestComplete"..descEnd; -- ...\Data\common.MPQ\Sound\Interface\iQuestComplete.wav -- Quest Comepleted
						elseif randomSound2 >= 7 and randomSound2 <= 8 then PSF("Sound\\Spells\\AchievmentSound1.wav"); soundPath = descSpell.."AchievmentSound1"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\AchievmentSound1.wav -- Achievement Gained
						elseif randomSound2 >= 9 and randomSound2 <= 10 then PSF("Sound\\Spells\\Resurrection.wav"); soundPath = descSpell.."Resurrection"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\Resurrection.wav -- Resurrection
						end
					else local randomSound2 = random(1, 4)
						if	   randomSound2 == 1 then local randomSound3 = random(1, 3); local a = "Sound\\Spells\\"
							if	   randomSound3 == 1 then PSF(a.."ValentineFirework.wav"); soundPath = descSpell.."ValentineFirework"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\ValentineFirework.wav
							elseif randomSound3 == 2 then PSF(a.."valentines_brokenheart.wav"); soundPath = descSpell.."valentines_brokenheart"..descEnd;
							elseif randomSound3 == 3 then PSF(a.."valentines_lookingforloveheart.wav"); soundPath = descSpell.."valentines_lookingforloveheart"..descEnd;
							end
						elseif randomSound2 == 2 then local randomSound3 = random(1, 7); local b = "Sound\\Character\\BloodElf\\BloodElfFemale"; local descBelf = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Character\\\\BloodElf\\\\BloodElfFemale|r|cff71D5FF"
							if	   randomSound3 == 1 then PSF(b.."Flirt01.wav"); soundPath = descBelf.."Flirt01"..descEnd; -- ...\Data\enGB\patch-enGB.MPQ\Sound\Character\BloodElf\BloodElfFemaleFlirt01.wav
							elseif randomSound3 == 2 then PSF(b.."Flirt02.wav"); soundPath = descBelf.."Flirt02"..descEnd;
							elseif randomSound3 == 3 then PSF(b.."Flirt04.wav"); soundPath = descBelf.."Flirt04"..descEnd;
							elseif randomSound3 == 4 then PSF(b.."Flirt05.wav"); soundPath = descBelf.."Flirt05"..descEnd;
							elseif randomSound3 == 5 then PSF(b.."Flirt10.wav"); soundPath = descBelf.."Flirt10"..descEnd;
							elseif randomSound3 == 6 then PSF(b.."Flirt11.wav"); soundPath = descBelf.."Flirt11"..descEnd;
							elseif randomSound3 == 7 then PSF(b.."Flirt13.wav"); soundPath = descBelf.."Flirt13"..descEnd;
							end
						elseif randomSound2 == 3 then PSF("Sound\\Creature\\Paletress\\AC_Paletress_Death01.wav"); soundPath = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FFAC_Paletress_Death01"..descEnd; -- ...\Data\enGB\patch-enGB.MPQ\Sound\Creature\Paletress\AC_Paletress_Death01.wav
						elseif randomSound2 == 4 then local randomSound3 = random(1, 8); local c = "Sound\\Creature\\Paletress\\AC_Paletress_Wound"; local descPaletress = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FF"
							if	   randomSound3 == 1 then PSF(c.."Light03.wav"); soundPath = descPaletress.."****03"..descEnd;
							elseif randomSound3 == 2 then PSF(c.."Medium01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 3 then PSF(c.."Heavy01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 4 then PSF(c.."Heavy02.wav"); soundPath = descPaletress.."****02"..descEnd;
							elseif randomSound3 == 5 then PSF(c.."Heavy03.wav"); soundPath = descPaletress.."****03"..descEnd;
							elseif randomSound3 == 6 then PSF(c.."Critical01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 7 then PSF(c.."Critical02.wav"); soundPath = descPaletress.."****02"..descEnd;
							elseif randomSound3 == 8 then PSF(c.."Critical03.wav"); soundPath = descPaletress.."****03"..descEnd;
							end
						end
					end
				end
			end,
			disabled = "OptionsDisabled",
		},
		executePrintRawLevelTimes = {
			type = "execute",
			order = 17,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t LevelData|r",
			func = function()
				if not RSD.db.char.levelTimeList or #RSD.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Data"].."]|r"); end
				for i = 2, maxLevel do if RSD.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: LevelData "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD.db.char.levelTimeList[i].."|r"); end; end
				end,
			disabled = "OptionsDisabled",
		},
		executePrintRawTotalTimes = {
			type = "execute",
			order = 18,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t TotalData|r",
			func = function()
				if not RSD.db.char.levelTimeList or #RSD.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Data"].."]|r"); end
				for i = 2, maxLevel do if RSD.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: TotalData "..L["Level"].." |cff71D5FF"..i.."|r: |cffB6CA00"..RSD.db.char.totalTimeList[i].."|r"); end; end
			end,
			disabled = "OptionsDisabled",
		},
		descriptionPlaySound = {
			type = "description",
			order = 19,
			name = function() if GetTime() < cd_playSound then return soundPath.."\n" else return "\n"; end; end, -- Sound Path Description
		},
		descriptionWindows7Logo = {
			type = "description",
			order = 20,
			name = function() return "|TInterface\\AddOns\\ReadySetDing\\Images\\ReadySet7:32:128:145:-45|t |TInterface\\AddOns\\ReadySetDing\\Images\\Windows7_Logo:64:64:299:-10|t"; end,
		},
	},
}

local optionsProfiles = { -- How to not show Profiles in a "group"? Its always shown in a tree/select/tab group .. then it gets a dark background
	type = "group",
	name = "",
	args = {
		profiles = {
			type = "group",
			name = "",
			inline = true,
			args = {
				profiles = {
					type = "group",
					name = "",
				},
			},
		},
	},
}

--	Blizzard GUI Defaults
local defaults = {
	profile = { -- "RSD.db.defaults.profile.*"
		enableAddOn = true,
		Screenshot = false,
		AutoGratz = false,
		BNetBroadcast = false,
		normalAnnounce = true,
		guildAnnounce = false,
		dingMessage = L["dingMessage"],

		showGuildLevelup = false,
		announceGuildLevelup = false,
		AllAchievements = false,
		screenshotDelay = 1,
		announceDelay = 0,
		autoGratzDelay = 0,
		autoGratzCooldown = 60,
		guildDingMsg = L["guildDingMsg"],
		autoGratzMsg1 = L["autoGratzMsg1"],
		autoGratzMsg2 = L["autoGratzMsg2"],
		autoGratzMsg3 = L["autoGratzMsg3"],
		autoGratzMsg4 = L["autoGratzMsg4"],
		autoGratzMsg5 = L["autoGratzMsg5"],
		
		Taunt = false,
		Interrupt = false,
		Dispel = false,
		Reflect = false,
		Death = false,
		Resurrection = false,
		CC_Applied = false,
		CC_Break = false,
		combatPvE = false,
		combatPvP = false,
		combatWorld = false,
		petGrowl = false,
		tankTaunt = false,
		tankBreaksCC = false,

		instanceTimer = false,
		instanceTimerMsg = L["instanceTimerMsg"],
		
		Debug = false, -- /run RSD.db.defaults.profile.Debug = true
	}, -- Shouldnt use an "execute" button option with "ReadySetDing.db:ResetDB("Default")" because that would also delete the preciousss Level Time data, well ... I think; Also cant use "RSD.db.profile:ResetDB("Default")" [Error: attempt to call method 'ResetDB' (a nil value)] for only resetting profile DB; Besides, there is a reset button at the profiles tab
	char = {
		chatFrame = 1
	},
}

	--------------------------------------------------
	-----  02 OnInitialize, OnEnable, OnDisable  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	--------------------------------------------------
function RSD:OnInitialize() -- Called when the AddOn is loaded
--	Creates a new database object that can be used to handle database settings and profiles -- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, true)

--	Register an options table with the AceConfig registry -- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	local ACR = LibStub("AceConfigRegistry-3.0")
	ACR:RegisterOptionsTable("appReadySetDing", optionsMain)
	ACR:RegisterOptionsTable("appRSD_Advanced", optionsAdvanced)
	ACR:RegisterOptionsTable("appRSD_Combat", optionsCombat)
	ACR:RegisterOptionsTable("appRSD_Timer", optionsInstanceTimer)
	ACR:RegisterOptionsTable("appRSD_About", optionsAbout)
	ACR:RegisterOptionsTable("appRSD_Profiles", optionsProfiles)
	
--	Add an options table into the Blizzard Interface Options panel -- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/	
	local ACD = LibStub("AceConfigDialog-3.0"); local optionsMainName = "Ready|cffADFF2FSet|r|cffFFFFFFDing|r  |TInterface\\AddOns\\ReadySetDing\\Images\\Windows7_Logo2:22:22:-4:0|t"
	self.optionsFrame = ACD:AddToBlizOptions("appReadySetDing", optionsMainName) -- Position: In Blizzard AddOn Options List; -- "self.optionsFrame" used for "InterfaceOptionsFrame_OpenToCategory"
	ACD:AddToBlizOptions("appRSD_Advanced", "|TInterface\\Icons\\Trade_Engineering:18:18:"..iconCropped.."|t  Advanced", optionsMainName)
	ACD:AddToBlizOptions("appRSD_Combat", "|TInterface\\Icons\\INV_Sword_01:18:18:"..iconCropped.."|t  Combat", optionsMainName)
	ACD:AddToBlizOptions("appRSD_Timer", "|TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:"..iconCropped.."|t  Instance Timer", optionsMainName)
	ACD:AddToBlizOptions("appRSD_About", "|TInterface\\Icons\\INV_Misc_QuestionMark:18:18:"..iconCropped.."|t  About", optionsMainName)
	ACD:AddToBlizOptions("appRSD_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t  Profiles", optionsMainName)
	
--	Get/Create a option table that you can use in your AddOn to control the profiles of AceDB-3.0 -- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	optionsProfiles.args.profiles.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) -- Dont rly understand the "group" it creates

--	Register chat commands -- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("rsd", "slashCommand")
	self:RegisterChatCommand("readyset", "slashCommand")
	self:RegisterChatCommand("readysetding", "slashCommand")
	
--	Define AceDB variables if yet undefined, so they can be used in AceConfigDialog options tables
	if not self.db.char.levelTimeList then self.db.char.levelTimeList = {}; end
	if not self.db.char.totalTimeList then self.db.char.totalTimeList = {}; end
	if not self.db.char.timeInstanceList then RSD.db.char.timeInstanceList = {}; end
	if not self.db.factionrealm.guildList then self.db.factionrealm.guildList = {}; end
	if not self.db.char.guildTexCoord then self.db.char.guildTexCoord = {}; end
	if not self.db.char.timeAFK then self.db.char.timeAFK = 0; end
	if not self.db.char.totalAFK then self.db.char.totalAFK = 0; end
	if not self.db.char.killingBlows then self.db.char.killingBlows = 0; end
	if not self.db.char.killingBlows2 then self.db.char.killingBlows2 = 0; end
	if not self.db.char.deathCount then self.db.char.deathCount = 0; end
	if not self.db.char.WintergraspDeaths then self.db.char.WintergraspDeaths = 0; end
	if not self.db.char.IsleConquestDeaths then self.db.char.IsleConquestDeaths = 0; end
	if not self.db.factionrealm.lastDate then self.db.factionrealm.lastDate = ""; end
	playerColor = RSD_UnitLinkClass("playerColor", nil, playerClass);
	CF = _G["ChatFrame"..self.db.char.chatFrame]
	timeLogin = GetTime() -- check for the first GuildRoster update, e.g. within 10 seconds after "timeLogin"

	if self.db.profile.enableAddOn == false then
		if self.db.profile.Debug == true then self:Print("Initialized, Disabling .. (|cff71D5FFOnInitialize|r)"); end -- For Debug purpose
		self:Disable() -- Turn AddOn off again at start if it was turned off at login/reload
	elseif self.db.profile.enableAddOn == true then
		if self.db.profile.Debug == true then self:Print("Initialized (|cff71D5FFOnInitialize|r)"); end
	end
end

function RSD:OnEnable() -- Called when the AddOn is enabled
--	Subscribe to Events
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")
	
	self:RegisterEvent("GUILD_ROSTER_UPDATE") -- Show Guild Member Dings
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") -- Instance Timer, Player Deaths, PvP Deaths
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE") -- Instance Timer
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED") -- Instance Timer (Backup Timer; re-enter same Instance)
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL") -- Instance Timer (Bosses that dont die or die multiple times; need LibBabble-Boss)
	self:RegisterEvent("CHAT_MSG_PARTY") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT") -- Auto Gratz ((Level) Achievements)
	self:RegisterEvent("CHAT_MSG_SYSTEM") -- AFK Time; Instance Timer Reset
	self:RegisterEvent("PLAYER_LEAVING_WORLD") -- AFK Time (Auto Logout)
	
	self:ScheduleTimer(function() -- http://www.wowace.com/addons/ace3/pages/api/ace-timer-3-0/
		if self.db.profile.enableAddOn == true and TPM_totalTime == 0 then RequestTimePlayed() -- If ReadySetDing was off at start and enabled afterwards, it has to request /played again, since it was Disabled()
			if self.db.profile.Debug == true then self:Print("Couldn't find \"|cff71D5FFTIME_PLAYED_MSG|r\" after 7 seconds delay. Calling \"|cff71D5FFRequestTimePlayed()|r\"... (|cff71D5FFOnEnable|r)")
			end
		elseif self.db.profile.enableAddOn == true and TPM_totalTime > 0 and self.db.profile.Debug == true then
			self:Print("\"|cff71D5FFTIME_PLAYED_MSG|r\" fired. Skipped \"|cff71D5FFRequestTimePlayed()|r\". (|cff71D5FFOnEnable|r)")
		end
	end, 7) -- Delay the request for 7seconds(slow computers need 3-5s), so that it waits for other AddOns first that want to request /played
	if self.db.profile.Debug == true then self:Print("Enabled (|cff71D5FFOnEnable|r)"); end -- For Debug purpose
	
--	refresh Guild Roster with repeating AceTimer; server side cooldown on GuildRoster() is 10 seconds
	if (self.db.profile.GuildLevelup == true or self.db.profile.GuildLevelup == nil) then self.GuildRosterTimer = self:ScheduleRepeatingTimer(function() GuildRoster(); end, 17); end
end 

function RSD:OnDisable() -- Called when the AddOn is disabled
	self:UnregisterAllEvents() -- Unsubscribe from all Events
	if self.db.profile.Debug == true then self:Print("Disabled (|cff71D5FFOnDisable|r)"); end -- For Debug purpose
end

	-----------------------------------
	-----  03  CALLBACK HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	-----------------------------------

function RSD:slashCommand(input) -- Process the slash command ('input' contains whatever follows the slash command)
	if not input or string.trim(input) == "" then InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) -- Instead of: /readysetding "ChatCommand", it will always go to options, since I don't understand "HandleCommand" ..
	--	LibStub("AceConfigCmd-3.0").HandleCommand(ReadySetDing, "rsd", "appReadySetDing") -- no idea how this works -- http://www.wowace.com/addons/ace3/pages/api/ace-config-cmd-3-0/
	end
end

function RSD:OptionsDisabled() -- Disables(gray out) options when AddOn disabled
	if RSD.db.profile.enableAddOn == true then return false; else return true; end
end

function RSD_GuildEmblem()
	if GuildFrameTabardEmblem then RSD.db.char.guildTexCoord = {GuildFrameTabardEmblem:GetTexCoord()}; end -- creating new tables = bad, i think; except dont know how to do it without the table
	if IsInGuild() and #RSD.db.char.guildTexCoord > 0 then return "|TInterface\\GuildFrame\\GuildEmblemsLG_01:32:32:-5:1:32:32:"..(RSD.db.char.guildTexCoord[1]*32)..":"..(RSD.db.char.guildTexCoord[7]*32)..":"..(RSD.db.char.guildTexCoord[2]*32)..":"..(RSD.db.char.guildTexCoord[8]*32).."|t";
	else return "|TInterface\\GuildFrame\\GuildLogo-NoLogo:32:32:-5:1|t";
	end
end

function RSD_TimetoString(time)
	local seconds = mod(floor(time),60) -- math.fmod; mod(47, 10) == 7 --> 47 divided by 10 return a remainder of 7
	local minutes = mod(floor(time/60),60)
	local hours = mod(floor(time/3600),24)
	local days = floor(time/86400)
	if time >= 0 and time < 60 then
		if	   seconds > 1	then return seconds.." "..L["seconds"] -- Recruit-a-Friend(RAF) level granting?
		elseif seconds == 1 then return seconds.." "..L["second"]
		elseif seconds == 0 then return seconds.." "..L["seconds"]; end
	elseif time >= 60 and time < 3600 then -- "4.2 minutes" vs "4 minutes, 12 seconds"?
		if	   seconds >= 6 then return minutes.."."..format("%.0f",floor(seconds/6)).." "..L["minutes"] -- floor for rounding down (otherwise "4.10" minutes)
		elseif minutes == 1 and seconds < 6 then return minutes.." "..L["minute"]
		elseif seconds >= 0 and seconds < 6 then return minutes.." "..L["minutes"]; end -- "minutes > 1"
	elseif time >= 3600 and time < 86400 then
		if	   hours >= 2 and minutes >= 2 then return hours.." "..L["hours"]..", "..minutes.." "..L["minutes"] -- 2 most significant Units of Time
		elseif hours == 1 and minutes >= 2 then return hours.." "..L["hour"]..", "..minutes.." "..L["minutes"]
		elseif hours >= 2 and minutes == 1 then return hours.." "..L["hours"]..", "..minutes.." "..L["minute"]
		elseif hours == 1 and minutes == 1 then return hours.." "..L["hour"]..", "..minutes.." "..L["minute"]
		elseif hours == 1 and minutes == 0 then return hours.." "..L["hour"]
		elseif hours >= 2 and minutes == 0 then return hours.." "..L["hours"]; end
	elseif time >= 86400 then
		if	   days >= 2 and hours >= 2 then return days.." "..L["days"]..", "..hours.." "..L["hours"]
		elseif days == 1 and hours >= 2 then return days.." "..L["day"]..", "..hours.." "..L["hours"]
		elseif days >= 2 and hours == 1 then return days.." "..L["days"]..", "..hours.." "..L["hour"]
		elseif days == 1 and hours == 1 then return days.." "..L["day"]..", "..hours.." "..L["hour"]
		elseif days == 1 and hours == 0 then return days.." "..L["day"]
		elseif days >= 2 and hours == 0 then return days.." "..L["days"]; end
	elseif time < 0 then return "[Error: Time is Negative]"
	end
end

function RSD_addedTime() -- called from fairly much everywhere (x9 places)
	return GetTime() - lastRequestedPlayedTime
end

function RSD_timeDiff(info)
	local timeDiff; local coloring1A; local coloring1B; local coloring2
	if RSD.db.char.levelTimeList[playerLevel] then
		if info == "exampleMsg" and TPM_currentLevelTime > 0 then timeDiff = RSD.db.char.levelTimeList[playerLevel] - (TPM_currentLevelTime+RSD_addedTime()); coloring1A = "|cffF6ADC6"; coloring1B = "|cffADFF2F"; coloring2 = "|r" -- TPM_currentLevelTime > 10 for checking if /played already fired
		elseif info == "dingMsg" and RSD.db.char.levelTimeList[playerLevel-1] then timeDiff = RSD.db.char.levelTimeList[playerLevel-1] - RSD.db.char.levelTimeList[playerLevel]; coloring1A = ""; coloring1B = ""; coloring2 = ""
		else timeDiff = 0
		end
	else timeDiff = 0
	end
	if timeDiff < 0 then return RSD_TimetoString(-timeDiff).." "..coloring1A..L["slower"]..coloring2 -- make positive if negative
	elseif timeDiff > 0 then return RSD_TimetoString(timeDiff).." "..coloring1B..L["faster"]..coloring2
	else return "["..L["No TimeDiff Data"].."]"
	end
end

function RSD_timeInstanceList(info) -- Save Instance Timer data to array
	local party1 = ""; local party2 = ""; local party3 = ""; local party4 = "" -- my _G[] with "for i = 1, 4 do" failed
		if UnitName("party1") then party1 = UnitName("party1"); else party1 = ""; end
		if UnitName("party2") then party2 = UnitName("party2"); else party2 = ""; end
		if UnitName("party3") then party3 = UnitName("party3"); else party3 = ""; end
		if UnitName("party4") then party4 = UnitName("party4"); else party4 = ""; end
	local a; if info then a = ": "..info.."]"; else a = "]"; end
	RSD.db.char.timeInstanceList[timeInstanceStart2.." - "..date("%Y.%m.%d %H:%M")] = "|cffADFF2F["..realZone..a.."|r in |cff71D5FF"..RSD_TimetoString(GetTime() - timeInstance)..".|r  "..party1..", "..party2..", "..party3..", "..party4
end

function RSD_recentLevelSpeed() -- [LEVEL] DingMsgVar; look for 5 levels difference, otherwise for smaller level differences
	local a = RSD.db.char.levelTimeList; local b = TPM_totalTime; local c = RSD.db.char.totalTimeList; local d = RSD_addedTime
	if a[playerLevel-4] then return ((a[playerLevel-4]+(b-c[playerLevel-4]))+d())/5	-- (levelTime[5-6]+([totalTime[10]-totalTime[6])+addedTime) / 4 --> (levelTime[5-6] + levelTime[6-10] + addedTime) / 5
	elseif a[playerLevel-3] then return ((a[playerLevel-3]+(b-c[playerLevel-3]))+d())/4
	elseif a[playerLevel-2] then return ((a[playerLevel-2]+(b-c[playerLevel-2]))+d())/3	-- (levelTime[7-8]+([totalTime[10]-totalTime[8])+addedTime) / 3 --> (levelTime[7-8] + levelTime[8-10] + addedTime) / 3
	elseif a[playerLevel-1] then return ((a[playerLevel-1]+(b-c[playerLevel-1]))+d())/2	-- (levelTime[8-9]+([totalTime[10]-totalTime[9])+addedTime) / 2 --> (levelTime[8-9] + levelTime[9-10] + addedTime) / 2
	elseif a[playerLevel] then return (a[playerLevel]+TPM_currentLevelTime+d()) -- special case: (levelTime[9-10] + TPM_currentLevelTime + addedTime)
	else return "["..L["No LevelSpeed Data"].."]"
	end
end

function RSD_LevelSummary(info) 
	if not RSD.db.char.levelHistoryStrJoin then RSD.db.char.levelHistoryStrJoin = " "..L["Level Summary"]..":  |cffF6ADC6["..L["No Level Data"].."]|r"; end
	if not RSD.db.char.levelHistory then RSD.db.char.levelHistory = {}; end -- Define arrays
	if not RSD.db.char.levelTimeList then RSD.db.char.levelTimeList = {}; end
	for i = 2, maxLevel do
		if RSD.db.char.levelTimeList[i] then
			for j = 1, 19 do
				if not RSD.db.char.levelHistory[j] then RSD.db.char.levelHistory[j] = ""; end -- string.join() cant take nil values ..
				if RSD.db.char.levelCounterA == j then RSD.db.char.levelHistory[j] = " "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r:  |cffB6CA00"..RSD_TimetoString(RSD.db.char.levelTimeList[i]).."|r        "..L["Total"]..":  |cff71D5FF"..RSD_TimetoString(RSD.db.char.totalTimeList[i]).."|r"
				end
			end
			RSD.db.char.levelHistoryStrJoin = strjoin("\n", -- 1 long string with linebreaks( \n ) as delimiter; need to better code this with "for i = 1, 19 do ..." or something
				RSD.db.char.levelHistory[1], RSD.db.char.levelHistory[2], RSD.db.char.levelHistory[3], RSD.db.char.levelHistory[4], RSD.db.char.levelHistory[5],
				RSD.db.char.levelHistory[6], RSD.db.char.levelHistory[7], RSD.db.char.levelHistory[8], RSD.db.char.levelHistory[9], RSD.db.char.levelHistory[10],
				RSD.db.char.levelHistory[11], RSD.db.char.levelHistory[12], RSD.db.char.levelHistory[13], RSD.db.char.levelHistory[14], RSD.db.char.levelHistory[15],
				RSD.db.char.levelHistory[16], RSD.db.char.levelHistory[17], RSD.db.char.levelHistory[18], RSD.db.char.levelHistory[19])
		end
	end
	if info == "LevelSummaryMenu" then return RSD.db.char.levelHistoryStrJoin; end
end

local function RSD_randomAutoGratzDelay() -- called from x3 places
	if RSD.db.profile.autoGratzDelay == 0 then return random(20,100)/10; else return RSD.db.profile.autoGratzDelay; end
end

local function RSD_randomAutoGratzMsg()
	local a = random(1, 5); -- called from x3 places
	if	   a == 1 then return RSD.db.profile.autoGratzMsg1
	elseif a == 2 then return RSD.db.profile.autoGratzMsg2
	elseif a == 3 then return RSD.db.profile.autoGratzMsg3
	elseif a == 4 then return RSD.db.profile.autoGratzMsg4
	elseif a == 5 then return RSD.db.profile.autoGratzMsg5
	end
--	return _G["ReadySetDingDB.profiles.Default.autoGratzMsg"..random(1,5)] -- grab from ReadySetDingDB; wtf I dont understand _G[] anymore ><
end

function RSD_expansionLimitLevel(info)
	local nextLevel
	if	   expansionLevel == 3 and playerLevel < 85 then nextLevel = playerLevel + 1; maxLevel = 85 -- Cataclysm
	elseif expansionLevel == 2 and playerLevel < 80 then nextLevel = playerLevel + 1; maxLevel = 80 -- Wrath of the Lich King
	elseif expansionLevel == 1 and playerLevel < 70 then nextLevel = playerLevel + 1; maxLevel = 70 -- The Burning Crusade
	elseif expansionLevel == 0 and playerLevel < 60 then nextLevel = playerLevel + 1; maxLevel = 60 -- Classic / Vanilla
	else nextLevel = "[Reached Max Level]"
	end
	if info == "exampleNextLevel" then return nextLevel
	elseif info == "examplePreviousLevel" then return playerLevel
	elseif info == "xRemainLevels" then return maxLevel - (playerLevel+1)
	elseif info == "remainLevels" then return maxLevel - playerLevel
	end
end

function RSD_AchievementStatistics(varType) -- See Wowhead Achievement Statistics;  http://www.wowhead.com/statistics
	if varType == "TotalKillingBlows" then -- [KILLS+] DingMsgVar
		if GetTime() > cd_StatisticTotalKillingBlows then cd_StatisticTotalKillingBlows = GetTime() + 60
			if GS(1491) == "--" then bgKills = 0; else bgKills = tonumber(GS(1491)); end -- 1491 = Battleground Killing Blows; GetStatistic(AchievementID) returns a string type, tonumber() makes it a number type
			if GS(1490) == "--" then arenaKills = 0; else arenaKills = tonumber(GS(1490)); end -- 1490 = Arena Killing Blows
		end
		return bgKills + arenaKills + RSD.db.char.killingBlows2
	elseif varType == "TotalDeaths" then
		if GS(60) == "--" then totalDeaths = 0; else totalDeaths = tonumber(GS(60)); end
		return totalDeaths;
	elseif varType == "excludeDeathsPvP" then -- [DEATHS-] DingMsgVar
		if GetTime() > cd_StatisticDeathsPvP then cd_StatisticDeathsPvP = GetTime() + 120
			if GS(60) == "--" then totalDeaths = 0; else totalDeaths = tonumber(GS(60)); end -- 60 = Total Deaths
			if GS(56) == "--" then PvP_WSG = 0; else PvP_WSG = tonumber(GS(56)); end -- 56 = Warsong Gulch
			if GS(57) == "--" then PvP_AB = 0; else PvP_AB = tonumber(GS(57)); end -- 59 = Arathi Basin
			if GS(59) == "--" then PvP_AV = 0; else PvP_AV = tonumber(GS(59)); end -- 57 = Alterac Valley
			if GS(1106) == "--" then PvP_EotS = 0; else PvP_EotS = tonumber(GS(1106)); end -- 1106 = Eye of the Storm
			if GS(1500) == "--" then PvP_SotA = 0; else PvP_SotA = tonumber(GS(1500)); end -- 1500 = Strand of the Ancients
			if GS(1057) == "--" then PvP_arena22 = 0; else PvP_arena22 = tonumber(GS(1057)); end -- 1057 = Arena 2v2
			if GS(1107) == "--" then PvP_arena33 = 0; else PvP_arena33 = tonumber(GS(1107)); end -- 1107 = Arena 3v3
			if GS(1108) == "--" then PvP_arena55 = 0; else PvP_arena55 = tonumber(GS(1108)); end -- 1108 = Arena 5v5
		end -- [No Isle of Conquest statistic], [No Wintergrasp statistic]
		return totalDeaths - (PvP_WSG+PvP_AB+PvP_AV+PvP_EotS+PvP_SotA+RSD.db.char.IsleConquestDeaths+PvP_arena22+PvP_arena33+PvP_arena55-RSD.db.char.WintergraspDeaths)
	elseif varType == "Quests" then -- [QUESTS] DingMsgVar
		if GetTime() > cd_StatisticTotalQuests then cd_StatisticTotalQuests = GetTime() + 60
			if GS(98) == "--" then questsTotal = 0; else questsTotal = tonumber(GS(98)); end -- 98 = Quests completed
			if GS(97) == "--" then questsDaily = 0; else questsDaily = tonumber(GS(97)); end -- 97 = Daily quests completed
		end
		return questsTotal - questsDaily -- Quests Completed(Achievement) = Quests completed(Statistic) - Daily qusts completed(Statistic); thank you aldon@wowhead
	end
end

function RSD_ReplaceText(msg, msgtype, extraInfo, guild1, guild2, guild3, guild4, guild5, guild6, guild7)
	if msgtype == "ExampleDingMsg" then
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..RSD_expansionLimitLevel("examplePreviousLevel").."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffF6ADC6"..RSD_expansionLimitLevel("exampleNextLevel").."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%#%]", "|cffF6ADC6"..RSD_expansionLimitLevel("xRemainLevels").."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%+%]", "|cffF6ADC6"..maxLevel.."|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..RSD_TimetoString(TPM_currentLevelTime+RSD_addedTime()).."|r")
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", "|cff71D5FF"..RSD_TimetoString(TPM_totalTime+RSD_addedTime()).."|r")
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..RSD_timeDiff("exampleMsg").."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", "|cff71D5FF"..RSD_TimetoString(RSD.db.char.timeAFK).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", "|cff71D5FF"..RSD_TimetoString(RSD.db.char.totalAFK).."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", "|cff0070DD"..date("%m/%d/%y %H:%M").."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", "|cff0070DD"..date("%Y.%m.%d %H:%M").."|r")
		if RSD_recentLevelSpeed() ~= "["..L["No LevelSpeed Data"].."]" then msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..format("%.2f",RSD_recentLevelSpeed()/3600).."|r")
		else msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffF6ADC6["..L["No LevelSpeed Data"].."]|r"); end
		if playerLevel > 1 then msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffB6CA00"..format("%.2f",(TPM_totalTime+RSD_addedTime())/(3600*(playerLevel-1))).."|r")
		else msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffF6ADC6["..L["No LevelSpeed Data"].."]|r"); end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", "|cffFF0000"..RSD.db.char.killingBlows.."|r")
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", "|cffFF0000"..RSD_AchievementStatistics("TotalKillingBlows").."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", "|cffFF0000"..RSD.db.char.deathCount.."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", "|cffFF0000"..RSD_AchievementStatistics("excludeDeathsPvP").."|r")
		if GetStatistic(60) == "--" then msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%#%]", "|cffFF00000|r")
		else msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%#%]", "|cffFF0000"..GetStatistic(60).."|r"); end
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", "|cff58ACFA"..RSD_AchievementStatistics("Quests").."|r")
		if GetRealZoneText() then msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cff58ACFA"..GetRealZoneText().."|r") -- not sure if its too early or aready avaiable at this point
		else msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6[No Zone Info]|r"); end
		if IsInGuild() and GetGuildInfo("player") then msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffADFF2F"..GetGuildInfo("player").."|r")
		else msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffF6ADC6[Not in Guild]|r"); end
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..playerName.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cffADFF2F"..playerClass.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", "|cffADFF2F"..playerRace.."|r")
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", "|cffADFF2F"..playerFaction.."|r")
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", "|cffADFF2F"..playerRealm.."|r")

		msg = gsub(msg, "%{[Rr][Tt]1%}", "|T"..RaidTarget.."1:12|t")
		msg = gsub(msg, "%{[Ss][Tt][Aa][Rr]%}", "|T"..RaidTarget.."1:12|t")
		msg = gsub(msg, "%{[Rr][Tt]2%}", "|T"..RaidTarget.."2:12|t")
		msg = gsub(msg, "%{[Cc][Ii][Rr][Cc][Ll][Ee]%}", "|T"..RaidTarget.."2:12|t")
		msg = gsub(msg, "%{[Cc][Oo][Ii][Nn]%}", "|T"..RaidTarget.."2:12|t")
		msg = gsub(msg, "%{[Rr][Tt]3%}", "|T"..RaidTarget.."3:12|t")
		msg = gsub(msg, "%{[Dd][Ii][Aa][Mm][Oo][Nn][Dd]%}", "|T"..RaidTarget.."3:12|t")
		msg = gsub(msg, "%{[Rr][Tt]4%}", "|T"..RaidTarget.."4:12|t")
		msg = gsub(msg, "%{[Tt][Rr][Ii][Aa][Nn][Gg][Ll][Ee]%}", "|T"..RaidTarget.."4:12|t")
		msg = gsub(msg, "%{[Rr][Tt]5%}", "|T"..RaidTarget.."5:12|t")
		msg = gsub(msg, "%{[Mm][Oo][Oo][Nn]%}", "|T"..RaidTarget.."5:12|t")
		msg = gsub(msg, "%{[Rr][Tt]6%}", "|T"..RaidTarget.."6:12|t")
		msg = gsub(msg, "%{[Ss][Qq][Uu][Aa][Rr][Ee]%}", "|T"..RaidTarget.."6:12|t")
		msg = gsub(msg, "%{[Rr][Tt]7%}", "|T"..RaidTarget.."7:12|t")
		msg = gsub(msg, "%{[Cc][Rr][Oo][Ss][Ss]%}", "|T"..RaidTarget.."7:12|t")
		msg = gsub(msg, "%{[Xx]%}", "|T"..RaidTarget.."7:12|t")
		msg = gsub(msg, "%{[Rr][Tt]8%}", "|T"..RaidTarget.."8:12|t")
		msg = gsub(msg, "%{[Ss][Kk][Uu][Ll][Ll]%}", "|T"..RaidTarget.."8:12|t")
		--[[
		if GetTime() > cd_checkMsgLength then cd_checkMsgLength = GetTime() + 3
			print(strlen(msg)); print(msg) -- [Test]
			if (RSD.db.profile.normalAnnounce == true or RSD.db.profile.guildAnnounce == true) and strlen(checkMsgLength) > 255 then print("|cffADFF2FReadySet|rDing: DingMessage is too long to announce (|cff71D5FF"..strlen(msg).."|r). Max Length = |cff71D5FF255|r chars."); print(checkMsgLength); end
		end
		--]]
		if RSD.db.profile.Debug == true then print(msg); end
		return msg
	elseif msgtype == "DingMsg" then
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", playerLevel-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", playerLevel)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%#%]", RSD_expansionLimitLevel("remainLevels"))
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%+%]", maxLevel)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", RSD_TimetoString(levelTime2))
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", RSD_TimetoString(TPM_totalTime))
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", RSD_timeDiff("dingMsg"))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", RSD_TimetoString(RSD.db.char.timeAFK))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", RSD_TimetoString(RSD.db.char.totalAFK))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", date("%m/%d/%y %H:%M"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", date("%Y.%m.%d %H:%M"))
		if RSD_recentLevelSpeed() ~= "["..L["No LevelSpeed Data"].."]" then msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", format("%.2f",RSD_recentLevelSpeed()/3600))
		else msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "["..L["No LevelSpeed Data"].."]"); end
		if playerLevel > 1 then msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", format("%.2f",(TPM_totalTime+RSD_addedTime())/(3600*(playerLevel-1))))
		else msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "["..L["No LevelSpeed Data"].."]"); end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", RSD.db.char.killingBlows)
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", RSD_AchievementStatistics("TotalKillingBlows"))
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", RSD.db.char.deathCount)
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", RSD_AchievementStatistics("excludeDeathsPvP"))
		if GetStatistic(60) == "--" then msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%#%]", 0)
		else msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%#%]", GetStatistic(60)); end
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", RSD_AchievementStatistics("Quests"))
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", GetRealZoneText())
		if IsInGuild() then msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", (select(1, GetGuildInfo("player"))))
		else msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "[Not in Guild]"); end
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", playerName)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", playerClass)
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", playerRace)
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", playerFaction)
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", playerRealm)
		if RSD.db.profile.Debug == true then print(msg); end
		return msg
	elseif msgtype == "GuildDingMsg" then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", guild1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", guild2)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", guild2-1)
		msg = gsub(msg, "%[[Tt][Ee][Ss][Tt][Dd][Ii][Ff][Ff]%]", guild7)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", guild3)
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", guild4)
		if guild5 then msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", guild5)
		else msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "[...]"); end -- sometimes "zone" is nil/empty
		return msg
	elseif msgtype == "LocalGuildDingMsg" then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..guild1.."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cff71D5FF"..guild2.."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..(guild2-1).."|r")
		msg = gsub(msg, "%[[Tt][Ee][Ss][Tt][Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..guild7.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cff4169E1"..guild3.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", "|cffF6ADC6"..guild4.."|r")
		if guild5 then msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cff0070DD"..guild5.."|r")
		else msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6[...]|r"); end
		return msg
	elseif msgtype == "AutoGratzMsg" then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", gratzName)
		return msg
	elseif msgtype == "ExampleInstanceTimerMsg" then
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", "|cff58ACFAHellfire Ramparts|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..RSD_TimetoString(1500).."|r")
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", "|cffADFF2F14:27|r")
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", "|cffF6ADC614:52|r")
		return msg
	elseif msgtype == "InstanceTimerMsg" then
		if extraInfo then msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText()..": "..extraInfo)
		else msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText()); end
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", RSD_TimetoString(GetTime() - timeInstance))
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", timeInstanceStart)
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", timeInstanceEnd)
		return msg
	end
end

-- Class Color, Unit Link
function RSD_UnitLinkClass(info, unitID, unitClass, unitGUID, sourceName, destName) -- http://www.wowpedia.org/Class_colors
	local classColor; local a;
	if	   unitClass == "DEATHKNIGHT" then classColor = "C41F3B";
	elseif unitClass == "DRUID"		  then classColor = "FF7D0A";
	elseif unitClass == "HUNTER"	  then classColor = "ABD473";
	elseif unitClass == "MAGE"		  then classColor = "69CCF0";
	elseif unitClass == "PALADIN"	  then classColor = "F58CBA";
	elseif unitClass == "PRIEST"	  then classColor = "FFFFFF";
	elseif unitClass == "ROGUE"		  then classColor = "FFF569";
	elseif unitClass == "SHAMAN"	  then classColor = "0070DE";
	elseif unitClass == "WARLOCK"	  then classColor = "9482C9";
	elseif unitClass == "WARRIOR"	  then classColor = "C79C6E";
	end
	if unitID == "group" and destName then a = UnitName(destName)
	elseif unitID == "group" and not destName then a = UnitName(sourceName)
	elseif unitID == "target" then a = UnitName("target")
	end
	if info == "source" then
		return "|cff"..classColor.."|Hunit:"..unitGUID.."|h["..a.."]|h|r"
	elseif info == "dest" then local b;
		if destName == sourceName then b = QUICKBUTTON_NAME_SELF; else b = a; end
		return "|cff"..classColor.."|Hunit:"..unitGUID.."|h["..b.."]|h|r"
	elseif info == "playerColor" then
		return classColor
	end
end

-- Spell School (Colored), Extra Spell School (Colored) -- http://www.wowpedia.org/API_COMBAT_LOG_EVENT#Spell_School
function RSD_spellSchool(value)
	local a; local b; local c = "71D5FF";
	if	   value == 0x1  then a = STRING_SCHOOL_PHYSICAL;	b = "FFFF00";
	elseif value == 0x2  then a = STRING_SCHOOL_HOLY;		b = "FFE680";
	elseif value == 0x4  then a = STRING_SCHOOL_FIRE;		b = "FF8000";
	elseif value == 0x8  then a = STRING_SCHOOL_NATURE;		b = "4DFF4D";
	elseif value == 0x10 then a = STRING_SCHOOL_FROST;		b = "80FFFF";
	elseif value == 0x20 then a = STRING_SCHOOL_SHADOW;		b = "8080FF";
	elseif value == 0x40 then a = STRING_SCHOOL_ARCANE;		b = "FF80FF";
--	Double schools
	elseif value == 0x3  then a = STRING_SCHOOL_HOLYSTRIKE;		b = c;
	elseif value == 0x5  then a = STRING_SCHOOL_FLAMESTRIKE;	b = c;
	elseif value == 0x6  then a = STRING_SCHOOL_HOLYFIRE;		b = c;
	elseif value == 0x9  then a = STRING_SCHOOL_STORMSTRIKE;	b = c;
	elseif value == 0xA  then a = STRING_SCHOOL_HOLYSTORM;		b = c;
	elseif value == 0xC  then a = STRING_SCHOOL_FIRESTORM;		b = c;
	elseif value == 0x11 then a = STRING_SCHOOL_FROSTSTRIKE;	b = c;
	elseif value == 0x12 then a = STRING_SCHOOL_HOLYFROST;		b = c;
	elseif value == 0x14 then a = STRING_SCHOOL_FROSTFIRE;		b = c;
	elseif value == 0x18 then a = STRING_SCHOOL_FROSTSTORM;		b = c;
	elseif value == 0x21 then a = STRING_SCHOOL_SHADOWSTRIKE;	b = c;
	elseif value == 0x22 then a = STRING_SCHOOL_SHADOWLIGHT;	b = c;
	elseif value == 0x24 then a = STRING_SCHOOL_SHADOWFLAME;	b = c;
	elseif value == 0x28 then a = STRING_SCHOOL_SHADOWSTORM;	b = c;
	elseif value == 0x30 then a = STRING_SCHOOL_SHADOWFROST;	b = c;
	elseif value == 0x41 then a = STRING_SCHOOL_SPELLSTRIKE;	b = c;
	elseif value == 0x42 then a = STRING_SCHOOL_DIVINE;			b = c;
	elseif value == 0x44 then a = STRING_SCHOOL_SPELLFIRE;		b = c;			
	elseif value == 0x48 then a = STRING_SCHOOL_SPELLSTORM;		b = c;
	elseif value == 0x50 then a = STRING_SCHOOL_SPELLFROST;		b = c;
	elseif value == 0x60 then a = STRING_SCHOOL_SPELLSHADOW;	b = c;
--	Three or more schools
	elseif value == 0x1C then a = STRING_SCHOOL_ELEMENTAL;	b = c;
	elseif value == 0x7C then a = STRING_SCHOOL_CHROMATIC;	b = c;
	elseif value == 0x7E then a = STRING_SCHOOL_MAGIC;		b = c;
	elseif value == 0x7F then a = STRING_SCHOOL_CHAOS;		b = c;
	else a = STRING_SCHOOL_UNKNOWN.." ("..value..")";		b = c;
	end
	return b, "|cff"..b..a.."|r" -- school(Name)Color, extraSchool(Name)Color
end

-- Unit Reaction (Colored), Raid Target Icon
function RSD_UnitFlags(info, Flags)
	if info == "reaction" then
		if band(Flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then return "57A3FF"; -- Friendly Reaction Color
		elseif band(Flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then return "BF0D0D"; -- Hostile Reaction Color
		else return "BFBFBF" -- Unknown Reaction Color
		end
	elseif info == "raidtarget" then
		local a = "";
		for i = 1, 8 do
			if band(Flags, _G["COMBATLOG_OBJECT_RAIDTARGET"..i]) > 0 then a = "|T"..RaidTarget..i..":16|t"; -- Raid Target Icon (only works in party/raid; so not when you're alone)
			end
		end
		return a
	end
end

	--------------------------------
	-----  04  EVENT HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  ----- 
	--------------------------------
function RSD:PLAYER_LEVEL_UP(event, ...) PLU_level = select(1, ...)
	playerDinged = true; playerLevel = PLU_level; RequestTimePlayed() -- /played -> "TIME_PLAYED_MSG" event

	if self.db.profile.Debug == true then self:Print("You dinged, requesting |cff71D5FF/played|r.."); end
	if not self.db.char.levelCounterA or self.db.char.levelCounterA >= 20 then self.db.char.levelCounterA = 0 -- Resets if leveled 20+ times
		if self.db.profile.Debug == true then self:Print("The LevelUp Counter doesn't exist yet, or exceeded 20; Changed back to 1."); end
	end self.db.char.levelCounterA = self.db.char.levelCounterA + 1
end

function RSD:TIME_PLAYED_MSG(event, ...) TPM_totalTime, TPM_currentLevelTime = select(1, ...)
	lastRequestedPlayedTime = GetTime()
	if playerDinged ~= true then TPM_totalTime2 = TPM_totalTime; TPM_currentLevelTime2 = TPM_currentLevelTime -- used to "guess" levelTime#1
	elseif playerDinged == true and TPM_currentLevelTime <= 7 then playerDinged = false -- 7 seconds grace period wherein the AddOn thinks the player has recently dinged

	--	A: Last undinged LevelTime + (dinged TotalTime - last undinged TotalTime); cant be used for in DingMsg examples, since it wont get refreshed (only when /played fires); GetTime() as in "addedTime" is used for that
		levelTime = TPM_currentLevelTime2 + (TPM_totalTime - TPM_totalTime2)
		TPM_totalTime2 = TPM_totalTime; TPM_currentLevelTime2 = TPM_currentLevelTime -- update time variables for next level
	--	B: TotalTime @ Ding - TotalTime @ previous Ding (more accurate)
		if self.db.char.totalTimeList[playerLevel-1] then
			levelTime2 = TPM_totalTime - self.db.char.totalTimeList[playerLevel-1]
		else levelTime2 = levelTime -- fall back to method A if no data for previous level
		end

		for i = 2, maxLevel do
			if playerLevel == i then -- Look for matching playerLevel and save it to the arrays
				self.db.char.levelTimeList[i] = levelTime2
				self.db.char.totalTimeList[i] = TPM_totalTime
			end
		end
		RSD_LevelSummary() -- save new LevelTime to Level Summary
	
	--	Announce Ding Message
		instanceType = select(2, IsInInstance())
		if instanceType == "none" and self.db.profile.normalAnnounce == true then
			if GetNumPartyMembers() > 0 then self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "PARTY"); end, self.db.profile.announceDelay) -- [Normal Announce: Party]; find out first if in a party
			else self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "SAY"); end, self.db.profile.announceDelay) -- [Normal Announce: Say]
			end
		elseif instanceType == "party" and self.db.profile.normalAnnounce == true then self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), instanceType); end, self.db.profile.announceDelay) -- Instance
		elseif instanceType == "raid" and self.db.profile.normalAnnounce == true then self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), instanceType); end, self.db.profile.announceDelay) -- Raid
		elseif instanceType == "pvp" and self.db.profile.normalAnnounce == true then self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "BATTLEGROUND"); end, self.db.profile.announceDelay) -- Battleground
		end
		if self.db.profile.BNetBroadcast == true then local broadcastMsg = (select(3, BNGetInfo())); self:ScheduleTimer(function() BNSetCustomMessage(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg")); BNSetCustomMessage(broadcastMsg); end, self.db.profile.announceDelay); end -- Real ID Broadcast; keep previous message if any
		if self.db.profile.guildAnnounce == true and IsInGuild() then self:ScheduleTimer(function() SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "GUILD"); end, self.db.profile.announceDelay); end -- Guild Announce
		if self.db.profile.Screenshot == true then self:ScheduleTimer(function() Screenshot(); end, self.db.profile.screenshotDelay); end -- Screenshot Feature; A little)(0.5-1.5 seconds) delay to show the LevelUp animation
		self.db.char.killingBlows = 0; self.db.char.deathCount = 0; self.db.char.timeAFK = 0; -- reset [KILLS], [DEATHS], [AFK] DingMessageVar
	end
end

function RSD:GUILD_ROSTER_UPDATE(event, ...) -- Show Guild Member Dings; this part is quite a mess =(
	local total, online = select(1, GetNumGuildMembers())
		
	if (self.db.profile.GuildLevelup == true or not self.db.profile.GuildLevelup) then -- check against tristate option, since "GUILD_ROSTER_UPDATE" (event) still fires when manually opening the Guild Roster
		local a; if not GetGuildRosterShowOffline() and GetTime() < timeLogin+60 then a = online; else a = total; end -- this will cause fps drops/freezes if you're in big guilds and offline members are showed! is this a "good" way? dont want to interfere with the Guild Roster options ><

		for i = 1, a do
			local name, rank, _, level, class, zone, _, _, online = GuildRosterInfo(i)
			
			if not self.db.factionrealm.guildList[name] then self.db.factionrealm.guildList[name] = level; end -- define key(character name) with value(level)
			if level > self.db.factionrealm.guildList[name] and GetTime() < timeLogin+60 then -- leveled multiple levels; show changed levels between sessions
				if showedLastDate ~= true and self.db.factionrealm.lastDate ~= "" then print("|cffADFF2FRSD|r: Level Changes since |cff71D5FF["..self.db.factionrealm.lastDate.."]|r"); showedLastDate = true; end
				local b = level - self.db.factionrealm.guildList[name]; local c; if b == 1 then c = L["Level"]; else c = L["Levels"]; end
				print("RSD: |cffADFF2F"..name.."|r leveled from Level |cffF6ADC6"..self.db.factionrealm.guildList[name].."|r to |cff71D5FF"..level.."|r |cffADFF2F("..b.." "..c..")|r")
			elseif level > self.db.factionrealm.guildList[name] and online and name ~= playerName then -- dinged and online
				self.db.factionrealm.guildList[name.."-"..level.."-date"] = date("%Y.%m.%d %H:%M") -- at least track the time/date at realtime ding for possible use in the future
				self.db.factionrealm.guildList[name.."-"..level.."-time"] = time() -- method2 (time since 1 jan 1970 in seconds; for diff times)
				local b = self.db.factionrealm.guildList; local c; if b[name.."-"..(level-1).."-time"] then c = "in "..RSD_TimetoString(b[name.."-"..(level).."-time"] - b[name.."-"..(level-1).."-time"]).." "; else c = ""; end -- test "realtime" level diff
				
				if self.db.profile.GuildLevelup == true then
					print("RSD: "..RSD_ReplaceText(self.db.profile.guildDingMsg, "LocalGuildDingMsg", nil, name, level, class, rank, zone, b[name], c))
				elseif self.db.profile.GuildLevelup == nil and (string.sub(level, 2, 2) ~= "0" and level ~= 85) then -- dont announce for lv 10, 20, 30, etc
					SCM(RSD_ReplaceText(self.db.profile.guildDingMsg, "GuildDingMsg", nil, name, level, class, rank, zone, b[name], c), "GUILD")
				end
			end
			self.db.factionrealm.guildList[name] = level; -- save level to array
		end
	end
end

local BossGUIDs = { -- Instance Timer; no need to localize with LibBabble-Boss if using GUIDs(Hex) instead of destName
--	[01-60] Classic Instance
	"027F", -- 639 Edwin VanCleef; The Deadmines
	"06B4", -- 1716 Bazil Thredd; The Stockade
	"073D", -- 1853 Darkmaster Gandling; Scholomance
	"0ABC", -- 2748 Archaedas; Uldaman
	"0F87", -- 3975 Herod; Scarlet Monastery: Armory
	"0F89", -- 3977 High Inquisitor Whitemane; Scarlet Monastery: Cathedral
	"0E46", -- 3654 Mutanus the Devourer; Wailing Caverns
	"10B3", -- 4275 Archmage Arugal; Shadowfang Keep
	"1145", -- 4421 Charlga Razorflank; Razorfen Kraul
	"11BF", -- 4543 Bloodmage Thalnos; Scarlet Monastery: Graveyard
	"12DD", -- 4829 Aku'mai; Blackfathom Deeps
	"164D", -- 5709 Shade of Eranikus; Sunken Temple
	"1957", -- 6487 Arcanist Doan; Scarlet Monastery: Library
	"1C63", -- 7267 Chief Ukorz Sandscalp; Zul'Farrak
	"1CBE", -- 7358 Amnennar the Coldbringer; Razorfen Downs
	"1E78", -- 7800 Mekgineer Thermaplugg; Gnomeregan
	"233A", -- 9018 High Interrogator Gerstahn; Blackrock Depths: Prison
	"233B", -- 9019 Emperor Dagran Thaurissan; Blackrock Depths: Upper City
	"2560", -- 9568 Overlord Wyrmthalak; Lower Blackrock Spire
	"28C8", -- 10440 Baron Rivendare; Stratholme: Main Gate
	"2A3D", -- 10813 Balnazzar; Stratholme: Service Entrance
	"2CDE", -- 11486 Prince Tortheldrin; Dire Maul: West
	"2CE4", -- 11492 Alzzin the Wildshaper; Dire Maul: East
	"2CED", -- 11501 King Gordok; Dire Maul: North
	"2D00", -- 11520 Taragaman the Hungerer; Ragefire Chasm
	"2FA9", -- 12201 Princess Theradras; Maraudon: Orange Crystals
	"2FCC", -- 12236 Lord Vyletongue; Maraudon: Purple Crystals
	"2FE2", -- 12258 Razorlash; Maraudon: Pristine Waters
--	[60-70] The Burning Crusade Instance
	"41A8", -- 16808 Warchief Kargath Bladefist; Hellfire Citadel: The Shattered Halls
	"43E1", -- 17377 Keli'dan the Breaker; Hellfire Citadel: The Blood Furnace
	"4480", -- 17536 Nazan; Hellfire Citadel: Hellfire Ramparts
	"4586", -- 17798 Warlord Kalithresh; Coilfang Reservoir: The Steamvault
	"45D9", -- 17881 Aeonus; Caverns of Time: The Black Morass
	"45DA", -- 17882 The Black Stalker; Coilfang Reservoir: The Underbog
	"4616", -- 17942 Quagmirran; Coilfang Reservoir: The Slave Pens
	"4639", -- 17977 Warp Splinter; Tempest Keep: The Botanica
	"47A8", -- 18344 Nexus-Prince Shaffar; Auchindoun: Mana-Tombs
	"47C5", -- 18373 Exarch Maladaar; Auchindoun: Auchenai Crypts
	"4829", -- 18473 Talon King Ikiss; Auchindoun: Sethekk Halls
	"4914", -- 18708 Murmur; Auchindoun: Shadow Labyrinth
	"46B0", -- 18096 Epoch Hunter; Caverns of Time: Old Hillsbrad Foothills
	"4B14", -- 19220 Pathaleon the Calculator; Tempest Keep: The Mechanar
	"51B0", -- 20912 Harbinger Skyriss; Tempest Keep: The Arcatraz
--	[70-80] Wrath of the Lich King Instance; Exclude: UK, ToC5, CoS, HoR (No/Multiple Boss Deaths)
	"6808", -- 26632 The Prophet Tharon'ja; Drak'Tharon Keep (name has an extra space at the end when transformed, GUID remains unchanged though)
	"6863", -- 26723 Keristrasza; The Nexus: The Nexus
	"68ED", -- 26861 King Ymiron; Utgarde Keep: Utgarde Pinnacle
	"6C08", -- 27656 Ley-Guardian Eregos; The Nexus: The Oculus
	"6D4A", -- 27978 Sjonnir The Ironshaper; Ulduar: Halls of Stone
	"70FB", -- 28923 Loken; Ulduar: Halls of Lightning
	"71C0", -- 29120 Anub'arak; Azjol-Nerub: Azjol-Nerub
	"727A", -- 29306 Gal'darah; Gundrak
	"727F", -- 29311 Herald Volazj; Azjol-Nerub: Ahn'kahet: The Old Kingdom
	"799E", -- 31134 Cyanigosa; The Violet Hold
	"8E96", -- 36502 Devourer of Souls; Icecrown Citadel: The Forge of Souls
	"8F32"	-- 36658 Scourgelord Tyrannus; Icecrown Citadel: Pit of Saron

--	"5D92"	-- 23954 Ingvar the Plunderer; Utgarde Keep: Utgarde Pinnacle (dies 2x)
--	"67A5"	-- 26533 Mal'Ganis; Caverns of Time: The Culling of Stratholme (doesnt die)
--	"8A7B"	-- 35451 The Black Knight; Crusaders' Coliseum: Trial of the Champion (dies 3x)
--	"905A"	-- 36954 The Lich King; Icecrown Citadel: Halls of Reflection (YOU CAAANT KILL THE LICH KING! d'oh~~)
}

---- Combat Events ---- for Instance Timer, Kills/Deaths counter, Custom Combat Log
function RSD:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3 = select(2, ...)
	local destNPC = strsub(destGUID, 7, 10) -- for Instance Timer, check against GUIDs instad of Names; strings instead of converted to decimal numbers(less workload right?)
	local destType = strsub(destGUID, 5, 5) -- for [KILLS], [KILLS+] dingmsgvar

--	refresh instanceType and realZone (1min cooldown)
	if GetTime() > cd_IsInInstance then cd_IsInInstance = GetTime() + 30; instanceType = select(2, IsInInstance()); end
	if GetTime() > cd_realZone then cd_realZone = GetTime() + 30; realZone = GetRealZoneText(); end
	
	if event == "UNIT_DIED" and destName == playerName then
		self.db.char.deathCount = self.db.char.deathCount + 1 -- [Deaths] DingMsgVar
	--	need LibBabble-Zone (localization) for GetRealZoneText()
		if realZone == "Isle of Conquest" then self.db.char.IsleConquestDeaths = self.db.char.IsleConquestDeaths + 1 -- [DEATHS-] Counter
		elseif realZone == "Wintergrasp" then self.db.char.WintergraspDeaths = self.db.char.WintergraspDeaths + 1
		end
	end

--	Overkill Events (killing blows), [KILLS] DingMsgVar
	if sourceName == playerName and destType == "0" then
		if ((event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0) or (event == "SWING_DAMAGE" and spellName > 0) and GetTime() > cd_PlayerKill then cd_PlayerKill = GetTime() + 1;
			self.db.char.killingBlows = self.db.char.killingBlows + 1; -- [KILLS] DingMsgVar
			if instanceType ~= "pvp" and instanceType ~= "arena" then self.db.char.killingBlows2 = self.db.char.killingBlows2 + 1; end
		end
	end

--## Instance Timer ## -- "LFG_COMPLETION_REWARD"(event) would be a suitable alternative, but it only works when queued for random dungeons
	if event == "UNIT_DIED" and self.db.profile.instanceTimer == true and instanceType == "party" and timeInstance > 0 then
		for _, v in pairs(BossGUIDs) do
			if v == destNPC then timeInstanceEnd = date("%H:%M"); -- need LibBabble-Zone for e.g. "[Scarlet Monastery: Library]", v0.71+ should have it.
			--	"Scarlet Monastery" -- 1 zone, split in 4 parts (they really are in the same map file)
				if	   destNPC == "11BF" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Graveyard"), "PARTY"); RSD_timeInstanceList("Graveyard") -- [27-37] Bloodmage Thalnos
				elseif destNPC == "1957" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Library"), "PARTY"); RSD_timeInstanceList("Library") -- [30-40] Arcanist Doan
				elseif destNPC == "0F87" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Armory"), "PARTY"); RSD_timeInstanceList("Armory") -- [32-42] Herod
				elseif destNPC == "0F89" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Cathedral"), "PARTY"); RSD_timeInstanceList("Cathedral") -- [35-45] High Inquisitor Whitemane -- even if Mograine is still alive and Whitemane dies, instance is considered completed by Blizz
			--	"Maraudon" -- 1 zone, split in 3 parts
				elseif destNPC == "2FCC" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Purple Crystals"), "PARTY"); timeInstance2 = timeInstance; RSD_timeInstanceList("Purple Crystals") -- [39-49] Lord Vyletongue -- timeInstance2 = another timer if group decides to continue instance
				elseif destNPC == "2FE2" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Orange Crystals"), "PARTY"); timeInstance2 = timeInstance; RSD_timeInstanceList("Orange Crystals") -- [41-51] Razorlash
				elseif destNPC == "2FA9" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Pristine Waters"), "PARTY"); RSD_timeInstanceList("Pristine Waters") -- [43-53] Princess Theradras
			--	"Blackrock Depths" -- 1 zone, split in 2 parts
				elseif destNPC == "233A" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Prison"), "PARTY"); timeInstance2 = timeInstance; RSD_timeInstanceList("Prison") -- [47-57] High Interrogator Gerstahn
				elseif destNPC == "233B" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Upper City"), "PARTY"); RSD_timeInstanceList("Upper City") -- [51-61] Emperor Dagran Thaurissan
			--	"Dire Maul" -- probably 1 zone, split into 3 parts, just like Scarlet Monastery
				elseif destNPC == "2CE4" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "East"), "PARTY"); RSD_timeInstanceList("East") -- [#53-63] Alzzin the Wildshaper
				elseif destNPC == "2CDE" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "West"), "PARTY"); RSD_timeInstanceList("West") -- [#55-65] Prince Tortheldrin
				elseif destNPC == "2CED" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "North"), "PARTY"); RSD_timeInstanceList("North") -- [#55-65] King Gordok
			--	"Stratholme" -- 1 zone, split in 2 parts
				elseif destNPC == "2A3D" then SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Main Gate"), "PARTY"); timeInstance2 = timeInstance; RSD_timeInstanceList("Main Gate") -- [#55-65] Balnazzar
				elseif destNPC == "28C8" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg", "Service Entrance"), "PARTY"); RSD_timeInstanceList("Service Entrance") -- [#55-65] Baron Rivendare
				else SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg"), "PARTY"); RSD_timeInstanceList()
				end
				timeInstance = 0; timeInstance2 = 0; timeInstanceStart = ""; timeInstanceStart2 = ""; timeInstanceEnd = ""; -- reset "timers"
			break
			end
		end
	end

--	InstanceType check (so the "workload" is optionally)
	if ((instanceType == "party" or instanceType == "raid") and self.db.profile.combatPvE == true) or ((instanceType == "pvp" or instanceType == "arena") and self.db.profile.combatPvP == true) or (instanceType == "none" and self.db.profile.combatWorld == true) then

	---- Ketho Combat Log ----
	--	Unit Type, Unit Reaction Coloring -- http://www.wowpedia.org/API_UnitGUID
		local sourceType = strsub(sourceGUID, 5, 5); --local destType = strsub(destGUID, 5, 5); -- 5th digit (string type); moved destType up for [KILLS], [KILLS+] dingmsgvar
		local sourceLink; local destLink;
		local sourceReaction = RSD_UnitFlags("reaction", sourceFlags); -- http://www.wowpedia.org/UnitFlag
		local destReaction = RSD_UnitFlags("reaction", destFlags);
		local sourceRT = RSD_UnitFlags("raidtarget", sourceFlags); 
		local destRT = RSD_UnitFlags("raidtarget", destFlags); 
		local schoolColor; local extraSchoolColor;
		local schoolNameColor; local extraSchoolNameColor;
		local spellIcon; local extraSpellIcon;
		local isTank = (UnitGroupRolesAssigned(sourceName) == "TANK")

	--	Unit Link -- http://www.wowpedia.org/UI_escape_sequences
		if sourceName then
			if sourceName == playerName then sourceLink = sourceRT.."|cff"..playerColor.."|Hunit:"..sourceGUID.."|h["..YOU.."]|h|r" -- You
			elseif UnitInParty(sourceName) or UnitInRaid(sourceName) then sourceLink = sourceRT..RSD_UnitLinkClass("source", "group", select(2,UnitClass(sourceName)), sourceGUID, sourceName) -- Party/Raid Class Color
			elseif sourceType == "0" and sourceName == UnitName("target") then sourceLink = sourceRT..RSD_UnitLinkClass("source", "target", select(2,UnitClass("target")), destGUID, sourceName) -- Target Class Color
			else sourceLink = sourceRT.."|cff"..sourceReaction.."|Hunit:"..sourceGUID.."|h["..sourceName.."]|h|r"
			end
		end
		if destName then local a;
			if destName == playerName then
				if sourceName == playerName then a = QUICKBUTTON_NAME_SELF; else a = YOU; end
				destLink = destRT.."|cff"..playerColor.."|Hunit:"..destGUID.."|h["..a.."]|h|r"
			elseif UnitInParty(destName) or UnitInRaid(destName) then destLink = destRT..RSD_UnitLinkClass("dest", "group", select(2,UnitClass(destName)), destGUID, sourceName, destName)
			elseif destType == "0" and destName == UnitName("target") then destLink = destRT..RSD_UnitLinkClass("dest", "target", select(2,UnitClass("target")), destGUID, sourceName, destName)
			else
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF; else a = destName; end
				destLink = destRT.."|cff"..destReaction.."|Hunit:"..destGUID.."|h["..a.."]|h|r"
			end
		end

		if event ~= "SWING_DAMAGE" and event ~= "SWING_MISSED" and event ~= "UNIT_DIED" and event ~= "PARTY_KILL" and event ~= "UNIT_DESTROYED" then
		--	Spell School (Colored)
			if spellSchool then schoolColor, schoolNameColor = RSD_spellSchool(spellSchool); end
		--	Spell Link + Colored
			spellLink = "|cff71d5ff|Hspell:"..spellID.."|h["..spellName.."]|h|r";
			spellLinkColor = "|cff"..schoolColor.."|Hspell:"..spellID.."|h["..spellName.."]|h|r";
		--	Spell Icon
			if (select(3, GetSpellInfo(spellID))) then
			spellIcon = "|T"..(select(3,GetSpellInfo(spellID)))..":16:16:"..iconCropped.."|t"; end

			if event == "SPELL_INTERRUPT" or event == "SPELL_DISPEL" or event == "SPELL_DISPEL_FAILED" or event == "SPELL_STOLEN" or event == "SPELL_AURA_BROKEN_SPELL" then
				if SuffixParam3 then extraSchoolColor, extraSchoolNameColor = RSD_spellSchool(SuffixParam3); end
				extraSpellLink = "|cff71d5ff|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r";
				extraSpellLinkColor = "|cff"..extraSchoolColor.."|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r";
				if (select(3, GetSpellInfo(SuffixParam1))) then
				extraSpellIcon = "|T"..(select(3,GetSpellInfo(SuffixParam1)))..":16:16:"..iconCropped.."|t"; end
			end
		end
----- ----- ----- ----- ----- ----- ----- ----- ----- -----

	--	Deaths
		if self.db.profile.Death == true and destType == "0" then -- lastDeath instead of a cooldown timer for against multiple killing blows, since a lot of (different) ppl will die in a short time
			if (event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0 and (GetTime() > cd_PlayerDeath or destName ~= lastDeath) then cd_PlayerDeath = GetTime() + 1; -- only take the first killing blow if there are multiple killing blows
				lastDeath = destName; local a; local b;
				if sourceName then a = sourceLink; else a = ""; end
				if destName == playerName then b = " ("..SuffixParam2.." "..L["overkill"]..")"; else b = ""; end
				CF:AddMessage(destLink.." "..ACTION_UNIT_DIED.." "..a..spellLinkColor..spellIcon.." "..SuffixParam1.." "..schoolNameColor..b)
		--	"SWING_DAMAGE" events uses a different args system (spellID, spellName, spellSchool are "skipped")
			elseif event == "SWING_DAMAGE" and spellName > 0 and (GetTime() > cd_PlayerDeath or destName ~= lastDeath) then cd_PlayerDeath = GetTime() + 1;
				lastDeath = destName; local b;
				if destName == playerName then b = " ("..spellName.." "..L["overkill"]..")"; else b = ""; end
				CF:AddMessage(destLink.." "..ACTION_UNIT_DIED.." "..sourceLink.." "..spellID.." |cffFFFF00"..MELEE.."|r"..b)
		--	Death Prevents
			elseif event == "SPELL_HEAL" and (spellID == 48153 or spellID == 66235) and self.db.profile.Death == true then -- Priest [Guardian Spirit]48153(SPELL_HEAL); Paladin [Ardent Defender] 66235(SPELL_HEAL)
				CF:AddMessage(sourceLink..spellLinkColor.." prevented death "..destLink.." "..SuffixParam1.." "..schoolNameColor)
			end
		end
	--	Taunts
		if self.db.profile.Taunt == true then
			if (event == "SPELL_AURA_APPLIED" or event == "SPELL_CAST_SUCCESS") and (instanceType ~= "party" or self.db.profile.tankTaunt == true or (self.db.profile.tankTaunt == false and isTank == false)) then
				if event == "SPELL_AURA_APPLIED" and destType == "3" and (spellID == 355 or spellID == 694 or spellID == 62124 or spellID == 31790 or spellID == 6795 or spellID == 56222 or spellID == 49560 or spellID == 51399 or spellID == 20736) then
					CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." taunted|r "..destLink); -- Normal Taunt; Local
				elseif event == "SPELL_CAST_SUCCESS" then
					if spellID == 1161 or spellID == 5209 or spellID == 59671 then -- AoE Taunt
						CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." AoE Taunt", 1, 0, 0); -- Warrior, Druid & Warlock AoE Taunt
					elseif spellID == 42650 then -- Death Knight [Army of the Dead]
						CF:AddMessage(sourceLink.." summoning "..spellLinkColor..spellIcon, 1, 0, 0);
					elseif sourceType == "4" and destType == "3" and self.db.profile.petGrowl == true and (spellName == "Growl" or spellName == "Torment" or spellName == "Suffering" or spellName == "Anguish") then
						CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." on "..destLink);
					end
				end
		--	Taunt Misses
			elseif event == "SPELL_MISSED" and (SuffixParam1 == "MISS" or SuffixParam1 == "IMMUNE" or SuffixParam1 == "RESIST") and destType == "3" and (spellID == 355 or spellID == 694 or spellID == 1161 or spellID == 62124 or spellID == 31790 or spellID == 6795 or spellID == 5209 or spellID == 56222 or spellID == 49560 or spellID == 51399) then -- Taunt missed
				CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." on "..destLink.." |cffFF7800failed|r ("..SuffixParam1..")");
			end
		end
	--	Interrupts
		if event == "SPELL_INTERRUPT" and self.db.profile.Interrupt == true then local a;
			if sourceName then a = sourceLink; else a = ""; end
			CF:AddMessage(a..spellLinkColor..spellIcon.." |cff006EFFinterrupted|r "..destLink..extraSpellLinkColor..extraSpellIcon);
	--	Reflects
		elseif event == "SPELL_MISSED" and SuffixParam1 == "REFLECT" and self.db.profile.Reflect == true then local a;
			if sourceName then a = sourceLink; else a = ""; end
			CF:AddMessage(destLink.." |cff71D5FFreflected|r "..a..spellLinkColor..spellIcon);
	--	Dispels
		elseif event == "SPELL_DISPEL" and self.db.profile.Dispel == true then
			CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." dispelled "..destLink..extraSpellLinkColor..extraSpellIcon);
	--	Spellsteals
		elseif event == "SPELL_STOLEN" and self.db.profile.Dispel == true then
			CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." stole "..destLink..extraSpellLinkColor..extraSpellIcon);
	--	Resurrections
		elseif event == "SPELL_RESURRECT" and self.db.profile.Resurrection == true and sourceType == "0" then
			CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." |cffC6DC00rezzed|r "..destLink);
	--	Crowd Control -- Crowd Control and CC Breaker will be spammy, especially in BGs, but it is a tradeoff for knowing if a CC got broken by a pet
		elseif event == "SPELL_AURA_APPLIED" and self.db.profile.CC_Applied == true then
			if spellName == "Polymorph" or spellName == "Sap" or spellName == "Shackle Undead" or spellName == "Hibernate" or spellName == "Banish" or spellName == "Freezing Trap" or spellName == "Wyvern Sting" or spellName == "Scare Beast" or spellName == "Turn Evil" or spellName == "Repentance" or spellName == "Blind" or spellName == "Hex" or spellName == "Seduction" then
				CF:AddMessage(sourceLink..spellLinkColor..spellIcon.." |cff71D5FFCC'ed|r "..destLink);
			end
	--	CC Breaker
		elseif (event == "SPELL_AURA_BROKEN" or event == "SPELL_AURA_BROKEN_SPELL") and self.db.profile.CC_Break == true and (instanceType ~= "party" or self.db.profile.tankBreaksCC == true or (self.db.profile.tankBreaksCC == false and isTank == false)) then
			if event == "SPELL_AURA_BROKEN" then -- not broken by a spell
				if sourceName then CF:AddMessage(sourceLink.." |cffFF7800broke|r "..spellLinkColor..spellIcon.." on "..destLink);
				else CF:AddMessage(spellLinkColor..spellIcon.." on "..destLink.." |cffFF7800broken|r");
				end
			elseif event == "SPELL_AURA_BROKEN_SPELL" then local a; -- broken by a spell
				if sourceName then a = sourceLink; else a = ""; end
				CF:AddMessage(a..extraSpellLinkColor..extraSpellIcon.." |cffFF7800broke|r "..spellLinkColor..spellIcon.." on "..destLink);
			end
		end
	end
end

function RSD:CHAT_MSG_CHANNEL_NOTICE(event, ...) local msg = select(1, ...)
	if msg == "YOU_CHANGED" then -- timeInstance -> File-local Scope variable instead of an Ace3 database variable, since often after a previous session it would return insane/negative times with GetTime() (its the time since your computer was on, so e.g. the pc was restarted/turned off); downside is that /reload or relogging will purge it
		if select(2, IsInInstance()) == "party" and (timeInstance == 0 or GetTime() > timeInstance + 7200) then timeInstance = GetTime(); timeInstanceStart = date("%H:%M"); timeInstanceStart2 = date("%Y.%m.%d %H:%M") -- automatic new timer if 2 hours since last instance time player entered instance; how to know if not re-entering an instance?
			if self.db.profile.Debug == true then self:Print("timeInstance = "..timeInstance); end
		end
	end
end

function RSD:LFG_PROPOSAL_SUCCEEDED(event, ...) -- test re-enter same Instance/Zone; backup timer if timeInstance still nil
	self:ScheduleTimer(function() if not timeInstance then timeInstance = GetTime(); timeInstanceStart = date("%H:%M"); timeInstanceStart2 = date("%Y.%m.%d %H:%M"); end; end, 30)
end

function RSD:CHAT_MSG_MONSTER_YELL(event, ...) local msg = select(1, ...) -- InstanceTimer -- LibBabble-Boss required for localization. v0.71+
	if self.db.profile.instanceTimer == true and instanceType == "party" and timeInstance > 0 then
		if	msg == "No! I can do... better! I can..." or -- "Utgarde Keep" (Boss dies twice)
			msg == "Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold." or -- "The Culling of Stratholme" (Boss doesn't die)
			msg == "No! I must not fail... again..." or -- "Trial of the Champion" (Boss dies x3); maybe shouldve checked against unitGUID...
			msg == "FIRE! FIRE!" then -- "Halls of Reflection" (no Boss; Escape Event)
			timeInstanceEnd = date("%H:%M"); SCM(RSD_ReplaceText(self.db.profile.instanceTimerMsg, "InstanceTimerMsg"), "PARTY");
			timeInstance = 0; timeInstance2 = 0; timeInstanceStart = ""; timeInstanceStart2 = ""; timeInstanceEnd = "";
		end
	end
end

--	Auto Gratz events -- dont alt+tab with auto gratz on, it will spam all "queued" dings once you alt+tab back in
--	rather than checking for different names, just a global cooldown/throttle, since I suspect it would be abused fairly much
function RSD:CHAT_MSG_PARTY(event, ...) local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and player ~= playerName and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and GetTime() > cd_autoGratzP then
		gratzName = player; cd_autoGratzP = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "PARTY"); end, RSD_randomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_GUILD(event, ...) local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and player ~= playerName and (strfind(msg, "[Dd][Ii][Nn][Gg]") or strfind(msg, L["Ding"])) and strlen(msg) <= 10 and GetTime() > cd_autoGratzG then
		gratzName = player; cd_autoGratzG = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "GUILD"); end, RSD_randomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_GUILD_ACHIEVEMENT(event, ...) local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and ((self.db.profile.gratzAllAchievements == false and strfind(msg, "Level")) or self.db.profile.gratzAllAchievements == true) and player ~= playerName and GetTime() > cd_autoGratzG then
		gratzName = player; cd_autoGratzG = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "GUILD"); end, RSD_randomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_SYSTEM(event, ...) local msg = select(1, ...) -- got a problem with "%s" in "MARKED_AFK_MESSAGE"
	if strfind(msg, L["You are now Away"]) then timeAFK1 = GetTime(); end -- MARKED_AFK == "You are now Away."; MARKED_AFK_MESSAGE == "You are now Away: %s"
	if msg == CLEARED_AFK and timeAFK1 then timeAFK2 = GetTime() -- CLEARED_AFK == "You are no longer Away."
		self.db.char.timeAFK = self.db.char.timeAFK + (timeAFK2-timeAFK1) -- [AFK] DingMsgVar
		self.db.char.totalAFK = self.db.char.totalAFK + (timeAFK2-timeAFK1) -- [AFK+] DingMsgVar
	end
	if msg == ERR_LEFT_GROUP_YOU or msg == ERR_UNINVITE_YOU then -- ERR_LEFT_GROUP_YOU == "You leave the group."; ERR_UNINVITE_YOU == "You have been removed from the group."
		timeInstance = 0 -- reset Instance Timer if left or kicked from group
	end
end

function RSD:PLAYER_LEAVING_WORLD(event, ...) -- [AFK], [AFK+] DingMsgVar; if player was afk long enough that he logs out automatically; (ofcourse wont work if player is alt+tabbed out!)
	self.db.char.testleaveworld = true
	if UnitIsAFK("player") and timeAFK1 then timeAFK2 = GetTime()
		self.db.char.timeAFK = self.db.char.timeAFK + (timeAFK2-timeAFK1)
		self.db.char.totalAFK = self.db.char.totalAFK + (timeAFK2-timeAFK1)
	end
	self.db.factionrealm.lastDate = date("%Y.%m.%d %H:%M"); -- this is the time at "logout", not actually the last time when Guild Roster was checked; this is assuming the Guild Ding option is enabled
end

	-------------------------
	-----  END OF ADDON ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----
	-------------------------
--[[
# Version History
	v0.74	2010.10.29  Fixed: Real ID Broadcast, Instance Backup Timer; Added: German Locale by Freydis88, Melikae and Littlelizzi
	v0.73	2010.10.28  Added Guild Dings Level and (test) Time diffs
	v0.72	2010.10.27  Hotfixed Guild Dings Announce: would still announce Guild Dings even though the option was turned off. (boolean(true/false(+nil)) logic with a "tristate" options toggle)
	v0.71	2010.10.27  Hotfixed Guild Dings Announce, so that it wont spam all level changes in guild but show it in the Local Chatframe properly now
	v0.70	2010.10.27  Added: [AFK], [AFK+], [KILLS], [KILLS+], [DEATHS-], [QUESTS], [REALM], [DATE] DingMsgVars;
						Fixed: [DEATHS], [DEATHS+] DingMsgVars; Announce Delay to 0.0 sec, previously 2 sec; Improved Instance Timer options; Code refactoring; Leaving/kicked from group now resets the Instance Timer; backup timer for when rejoining same instance
						Improved [SPEED] variable to also take 1-4 levels difference; GlobalStrings.lua Localization, Combat MiniMod
						.. and lot of undocumented changes: code refactoring, design, tweaks
	v0.63	2010.10.15  Fixed: [GUILD] description that was called too early
	v0.62	2010.10.15  < BROKEN> Fixed: [GUILD], [ZONE] DingMsg Variable; Added: [CLASS], [RACE], [FACTION] DingMsg Variable; Changed AutoGratz LimitLength to Announce Delay
	v0.61	2010.10.14  Lots of Bugfixes (great feedback by Eincrou@WoWInterface); Code refactoring; Added even more DingMessage Variables
	v0.60	2010.10.13  < BROKEN> First try at Localizations; Added more DingMessage variables, Leveling Speed, Instance Timer; Removed DingMessage Validate since you get a feedback example; coded messy because of v4.0.1 deadline
	v0.52	2010.09.04  Fixed Table of Contents (.TOC) Title; Added ReadySet7 Images; Cleaned up [Advanced] Options tab
	v0.51	2010.09.04	Removed Camera Max Distance by request, Code refactoring(Variable Scoping)
	v0.5	2010.09.01	Added Ding Emote, Real ID Broadcast, Ding Summary
	v0.4	2010.03.18	Added Custom Ding Message, Screenshot option
	v0.3	2010.01.29	Added GUI Options, Slash Commands, embeded Ace3 libs
	v0.2	2010.01.10	Released again, made some (stupid?) error
	v0.1	2010.01.10	< BROKEN> Release
	
# Links
	AddOn: Curse						http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
	AddOn: WoWInterface					http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
	Thread: WoWInterface				http://www.wowinterface.com/forums/showthread.php?t=36333
	Thread: WowAce						http://forums.wowace.com/showthread.php?t=18511
	Extract: Ladik's MPQ Editor			http://zezula.net/en/mpq/download.html
	.BLP: BLP2PNG						http://www.wowinterface.com/downloads/info6127-BLP2PNG.html
	.BLP: XnView						http://xnview.com/
--]]